#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 585
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 197
#define ALIAS_COUNT 0
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 73

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_return = 3,
  anon_sym_SEMI = 4,
  anon_sym_EQ = 5,
  anon_sym_COMMA = 6,
  sym_break_statement = 7,
  anon_sym_do = 8,
  anon_sym_end = 9,
  anon_sym_while = 10,
  anon_sym_repeat = 11,
  anon_sym_until = 12,
  anon_sym_if = 13,
  anon_sym_then = 14,
  anon_sym_elseif = 15,
  anon_sym_else = 16,
  anon_sym_for = 17,
  anon_sym_in = 18,
  anon_sym_function = 19,
  anon_sym_local = 20,
  anon_sym_DOT = 21,
  anon_sym_COLON = 22,
  anon_sym_LT = 23,
  anon_sym_GT = 24,
  anon_sym_nil = 25,
  sym_false = 26,
  sym_true = 27,
  sym_number = 28,
  anon_sym_DQUOTE = 29,
  anon_sym_SQUOTE = 30,
  aux_sym__doublequote_string_content_token1 = 31,
  aux_sym__singlequote_string_content_token1 = 32,
  sym_escape_sequence = 33,
  anon_sym_DOT_DOT_DOT = 34,
  anon_sym_LPAREN = 35,
  anon_sym_RPAREN = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_LBRACE = 39,
  anon_sym_RBRACE = 40,
  anon_sym_or = 41,
  anon_sym_and = 42,
  anon_sym_LT_EQ = 43,
  anon_sym_EQ_EQ = 44,
  anon_sym_TILDE_EQ = 45,
  anon_sym_GT_EQ = 46,
  anon_sym_PLUS = 47,
  anon_sym_DASH = 48,
  anon_sym_STAR = 49,
  anon_sym_SLASH = 50,
  anon_sym_SLASH_SLASH = 51,
  anon_sym_PERCENT = 52,
  anon_sym_DOT_DOT = 53,
  anon_sym_CARET = 54,
  anon_sym_not = 55,
  anon_sym_POUND = 56,
  anon_sym_DASH_DASH = 57,
  aux_sym_comment_token1 = 58,
  anon_sym_PLUS_EQ = 59,
  anon_sym_DASH_EQ = 60,
  anon_sym_STAR_EQ = 61,
  anon_sym_SLASH_EQ = 62,
  anon_sym_PERCENT_EQ = 63,
  anon_sym_SLASH_SLASH_EQ = 64,
  anon_sym_CARET_EQ = 65,
  anon_sym_DOT_DOT_EQ = 66,
  sym_continue_statement = 67,
  anon_sym_export = 68,
  anon_sym_type = 69,
  anon_sym_typeof = 70,
  anon_sym_thread = 71,
  anon_sym_buffer = 72,
  anon_sym_any = 73,
  anon_sym_userdata = 74,
  anon_sym_unknown = 75,
  anon_sym_never = 76,
  anon_sym_string = 77,
  anon_sym_number = 78,
  anon_sym_table = 79,
  anon_sym_boolean = 80,
  anon_sym_DASH_GT = 81,
  anon_sym_LT2 = 82,
  anon_sym_PIPE = 83,
  anon_sym_AMP = 84,
  anon_sym_QMARK = 85,
  anon_sym_COLON_COLON = 86,
  anon_sym_BQUOTE = 87,
  aux_sym__interpolation_string_content_token1 = 88,
  anon_sym_BSLASH_LBRACE = 89,
  aux_sym__escape_sequence_token1 = 90,
  sym__block_comment_start = 91,
  sym__block_comment_content = 92,
  sym__block_comment_end = 93,
  sym__block_string_start = 94,
  sym__block_string_content = 95,
  sym__block_string_end = 96,
  sym_chunk = 97,
  sym__block = 98,
  sym_statement = 99,
  sym_return_statement = 100,
  sym_empty_statement = 101,
  sym_assignment_statement = 102,
  sym__variable_assignment_varlist = 103,
  sym__variable_assignment_explist = 104,
  sym_do_statement = 105,
  sym_while_statement = 106,
  sym_repeat_statement = 107,
  sym_if_statement = 108,
  sym_elseif_statement = 109,
  sym_else_statement = 110,
  sym_for_statement = 111,
  sym_for_generic_clause = 112,
  sym_for_numeric_clause = 113,
  sym_declaration = 114,
  sym_function_declaration = 115,
  sym__local_function_declaration = 116,
  sym__function_name = 117,
  sym__function_name_prefix_expression = 118,
  sym__function_name_dot_index_expression = 119,
  sym__function_name_method_index_expression = 120,
  sym_variable_declaration = 121,
  sym__local_variable_assignment = 122,
  sym__att_name_list = 123,
  sym__attrib = 124,
  sym__expression_list = 125,
  sym_expression = 126,
  sym_nil = 127,
  sym_string = 128,
  sym__quote_string = 129,
  aux_sym__doublequote_string_content = 130,
  aux_sym__singlequote_string_content = 131,
  sym__block_string = 132,
  sym_vararg_expression = 133,
  sym_function_definition = 134,
  sym__function_body = 135,
  sym_parameters = 136,
  sym__parameter_list = 137,
  sym__prefix_expression = 138,
  sym_variable = 139,
  sym_bracket_index_expression = 140,
  sym_dot_index_expression = 141,
  sym_function_call = 142,
  sym_method_index_expression = 143,
  sym_arguments = 144,
  sym_parenthesized_expression = 145,
  sym_table_constructor = 146,
  sym__field_list = 147,
  sym__field_sep = 148,
  sym_field = 149,
  sym_binary_expression = 150,
  sym_unary_expression = 151,
  sym_comment = 152,
  sym_update_statement = 153,
  sym_type_definition = 154,
  sym_generic_type_list = 155,
  sym_parameter = 156,
  sym_type = 157,
  sym_builtin_type = 158,
  sym_tuple_type = 159,
  sym_function_type = 160,
  sym_generic_type = 161,
  sym_object_type = 162,
  sym_empty_type = 163,
  sym_field_type = 164,
  sym_object_field_type = 165,
  sym_union_type = 166,
  sym_intersection_type = 167,
  sym_optional_type = 168,
  sym_literal_type = 169,
  sym_variadic_type = 170,
  sym_cast_expression = 171,
  sym_if_expression = 172,
  sym_elseif_clause = 173,
  sym_else_clause = 174,
  sym__binding_list = 175,
  sym__interpolated_string = 176,
  sym__interpolation_string_content = 177,
  sym__escape_sequence = 178,
  sym_interpolation = 179,
  aux_sym_chunk_repeat1 = 180,
  aux_sym__variable_assignment_varlist_repeat1 = 181,
  aux_sym__variable_assignment_explist_repeat1 = 182,
  aux_sym_if_statement_repeat1 = 183,
  aux_sym__att_name_list_repeat1 = 184,
  aux_sym__expression_list_repeat1 = 185,
  aux_sym__parameter_list_repeat1 = 186,
  aux_sym__field_list_repeat1 = 187,
  aux_sym_generic_type_list_repeat1 = 188,
  aux_sym_tuple_type_repeat1 = 189,
  aux_sym_function_type_repeat1 = 190,
  aux_sym_generic_type_repeat1 = 191,
  aux_sym_object_type_repeat1 = 192,
  aux_sym_field_type_repeat1 = 193,
  aux_sym_if_expression_repeat1 = 194,
  aux_sym__binding_list_repeat1 = 195,
  aux_sym__interpolated_string_repeat1 = 196,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_return] = "return",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [sym_break_statement] = "break_statement",
  [anon_sym_do] = "do",
  [anon_sym_end] = "end",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_until] = "until",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_function] = "function",
  [anon_sym_local] = "local",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON] = ":",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_nil] = "nil",
  [sym_false] = "false",
  [sym_true] = "true",
  [sym_number] = "number",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [aux_sym__doublequote_string_content_token1] = "_doublequote_string_content_token1",
  [aux_sym__singlequote_string_content_token1] = "_singlequote_string_content_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_CARET] = "^",
  [anon_sym_not] = "not",
  [anon_sym_POUND] = "#",
  [anon_sym_DASH_DASH] = "--",
  [aux_sym_comment_token1] = "comment_content",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_export] = "export",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_thread] = "thread",
  [anon_sym_buffer] = "buffer",
  [anon_sym_any] = "any",
  [anon_sym_userdata] = "userdata",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_string] = "string",
  [anon_sym_number] = "number",
  [anon_sym_table] = "table",
  [anon_sym_boolean] = "boolean",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_LT2] = "<",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__interpolation_string_content_token1] = "_interpolation_string_content_token1",
  [anon_sym_BSLASH_LBRACE] = "\\{",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym__block_comment_start] = "[[",
  [sym__block_comment_content] = "comment_content",
  [sym__block_comment_end] = "]]",
  [sym__block_string_start] = "[[",
  [sym__block_string_content] = "string_content",
  [sym__block_string_end] = "]]",
  [sym_chunk] = "chunk",
  [sym__block] = "block",
  [sym_statement] = "statement",
  [sym_return_statement] = "return_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym__variable_assignment_varlist] = "variable_list",
  [sym__variable_assignment_explist] = "expression_list",
  [sym_do_statement] = "do_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_statement] = "elseif_statement",
  [sym_else_statement] = "else_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_generic_clause] = "for_generic_clause",
  [sym_for_numeric_clause] = "for_numeric_clause",
  [sym_declaration] = "declaration",
  [sym_function_declaration] = "function_declaration",
  [sym__local_function_declaration] = "function_declaration",
  [sym__function_name] = "_function_name",
  [sym__function_name_prefix_expression] = "_function_name_prefix_expression",
  [sym__function_name_dot_index_expression] = "dot_index_expression",
  [sym__function_name_method_index_expression] = "method_index_expression",
  [sym_variable_declaration] = "variable_declaration",
  [sym__local_variable_assignment] = "assignment_statement",
  [sym__att_name_list] = "variable_list",
  [sym__attrib] = "attribute",
  [sym__expression_list] = "expression_list",
  [sym_expression] = "expression",
  [sym_nil] = "nil",
  [sym_string] = "string",
  [sym__quote_string] = "_quote_string",
  [aux_sym__doublequote_string_content] = "_doublequote_string_content",
  [aux_sym__singlequote_string_content] = "_singlequote_string_content",
  [sym__block_string] = "_block_string",
  [sym_vararg_expression] = "vararg_expression",
  [sym_function_definition] = "function_definition",
  [sym__function_body] = "_function_body",
  [sym_parameters] = "parameters",
  [sym__parameter_list] = "_parameter_list",
  [sym__prefix_expression] = "_prefix_expression",
  [sym_variable] = "variable",
  [sym_bracket_index_expression] = "bracket_index_expression",
  [sym_dot_index_expression] = "dot_index_expression",
  [sym_function_call] = "function_call",
  [sym_method_index_expression] = "method_index_expression",
  [sym_arguments] = "arguments",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_table_constructor] = "table_constructor",
  [sym__field_list] = "_field_list",
  [sym__field_sep] = "_field_sep",
  [sym_field] = "field",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_comment] = "comment",
  [sym_update_statement] = "update_statement",
  [sym_type_definition] = "type_definition",
  [sym_generic_type_list] = "generic_type_list",
  [sym_parameter] = "parameter",
  [sym_type] = "type",
  [sym_builtin_type] = "builtin_type",
  [sym_tuple_type] = "tuple_type",
  [sym_function_type] = "function_type",
  [sym_generic_type] = "generic_type",
  [sym_object_type] = "object_type",
  [sym_empty_type] = "empty_type",
  [sym_field_type] = "field_type",
  [sym_object_field_type] = "object_field_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_optional_type] = "optional_type",
  [sym_literal_type] = "literal_type",
  [sym_variadic_type] = "variadic_type",
  [sym_cast_expression] = "cast_expression",
  [sym_if_expression] = "if_expression",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym__binding_list] = "variable_list",
  [sym__interpolated_string] = "_interpolated_string",
  [sym__interpolation_string_content] = "string_content",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_interpolation] = "interpolation",
  [aux_sym_chunk_repeat1] = "chunk_repeat1",
  [aux_sym__variable_assignment_varlist_repeat1] = "_variable_assignment_varlist_repeat1",
  [aux_sym__variable_assignment_explist_repeat1] = "_variable_assignment_explist_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym__att_name_list_repeat1] = "_att_name_list_repeat1",
  [aux_sym__expression_list_repeat1] = "_expression_list_repeat1",
  [aux_sym__parameter_list_repeat1] = "_parameter_list_repeat1",
  [aux_sym__field_list_repeat1] = "_field_list_repeat1",
  [aux_sym_generic_type_list_repeat1] = "generic_type_list_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_function_type_repeat1] = "function_type_repeat1",
  [aux_sym_generic_type_repeat1] = "generic_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_field_type_repeat1] = "field_type_repeat1",
  [aux_sym_if_expression_repeat1] = "if_expression_repeat1",
  [aux_sym__binding_list_repeat1] = "_binding_list_repeat1",
  [aux_sym__interpolated_string_repeat1] = "_interpolated_string_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_break_statement] = sym_break_statement,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_nil] = anon_sym_nil,
  [sym_false] = sym_false,
  [sym_true] = sym_true,
  [sym_number] = sym_number,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym__doublequote_string_content_token1] = aux_sym__doublequote_string_content_token1,
  [aux_sym__singlequote_string_content_token1] = aux_sym__singlequote_string_content_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [aux_sym_comment_token1] = sym__block_comment_content,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [sym_continue_statement] = sym_continue_statement,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_thread] = anon_sym_thread,
  [anon_sym_buffer] = anon_sym_buffer,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_userdata] = anon_sym_userdata,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_table] = anon_sym_table,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__interpolation_string_content_token1] = aux_sym__interpolation_string_content_token1,
  [anon_sym_BSLASH_LBRACE] = anon_sym_BSLASH_LBRACE,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym__block_comment_start] = sym__block_comment_start,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__block_comment_end] = sym__block_comment_end,
  [sym__block_string_start] = sym__block_comment_start,
  [sym__block_string_content] = sym__block_string_content,
  [sym__block_string_end] = sym__block_comment_end,
  [sym_chunk] = sym_chunk,
  [sym__block] = sym__block,
  [sym_statement] = sym_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym__variable_assignment_varlist] = sym__variable_assignment_varlist,
  [sym__variable_assignment_explist] = sym__variable_assignment_explist,
  [sym_do_statement] = sym_do_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_statement] = sym_elseif_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_generic_clause] = sym_for_generic_clause,
  [sym_for_numeric_clause] = sym_for_numeric_clause,
  [sym_declaration] = sym_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym__local_function_declaration] = sym_function_declaration,
  [sym__function_name] = sym__function_name,
  [sym__function_name_prefix_expression] = sym__function_name_prefix_expression,
  [sym__function_name_dot_index_expression] = sym_dot_index_expression,
  [sym__function_name_method_index_expression] = sym_method_index_expression,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__local_variable_assignment] = sym_assignment_statement,
  [sym__att_name_list] = sym__variable_assignment_varlist,
  [sym__attrib] = sym__attrib,
  [sym__expression_list] = sym__variable_assignment_explist,
  [sym_expression] = sym_expression,
  [sym_nil] = sym_nil,
  [sym_string] = sym_string,
  [sym__quote_string] = sym__quote_string,
  [aux_sym__doublequote_string_content] = aux_sym__doublequote_string_content,
  [aux_sym__singlequote_string_content] = aux_sym__singlequote_string_content,
  [sym__block_string] = sym__block_string,
  [sym_vararg_expression] = sym_vararg_expression,
  [sym_function_definition] = sym_function_definition,
  [sym__function_body] = sym__function_body,
  [sym_parameters] = sym_parameters,
  [sym__parameter_list] = sym__parameter_list,
  [sym__prefix_expression] = sym__prefix_expression,
  [sym_variable] = sym_variable,
  [sym_bracket_index_expression] = sym_bracket_index_expression,
  [sym_dot_index_expression] = sym_dot_index_expression,
  [sym_function_call] = sym_function_call,
  [sym_method_index_expression] = sym_method_index_expression,
  [sym_arguments] = sym_arguments,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_table_constructor] = sym_table_constructor,
  [sym__field_list] = sym__field_list,
  [sym__field_sep] = sym__field_sep,
  [sym_field] = sym_field,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_comment] = sym_comment,
  [sym_update_statement] = sym_update_statement,
  [sym_type_definition] = sym_type_definition,
  [sym_generic_type_list] = sym_generic_type_list,
  [sym_parameter] = sym_parameter,
  [sym_type] = sym_type,
  [sym_builtin_type] = sym_builtin_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_function_type] = sym_function_type,
  [sym_generic_type] = sym_generic_type,
  [sym_object_type] = sym_object_type,
  [sym_empty_type] = sym_empty_type,
  [sym_field_type] = sym_field_type,
  [sym_object_field_type] = sym_object_field_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_optional_type] = sym_optional_type,
  [sym_literal_type] = sym_literal_type,
  [sym_variadic_type] = sym_variadic_type,
  [sym_cast_expression] = sym_cast_expression,
  [sym_if_expression] = sym_if_expression,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym__binding_list] = sym__variable_assignment_varlist,
  [sym__interpolated_string] = sym__interpolated_string,
  [sym__interpolation_string_content] = sym__block_string_content,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_interpolation] = sym_interpolation,
  [aux_sym_chunk_repeat1] = aux_sym_chunk_repeat1,
  [aux_sym__variable_assignment_varlist_repeat1] = aux_sym__variable_assignment_varlist_repeat1,
  [aux_sym__variable_assignment_explist_repeat1] = aux_sym__variable_assignment_explist_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym__att_name_list_repeat1] = aux_sym__att_name_list_repeat1,
  [aux_sym__expression_list_repeat1] = aux_sym__expression_list_repeat1,
  [aux_sym__parameter_list_repeat1] = aux_sym__parameter_list_repeat1,
  [aux_sym__field_list_repeat1] = aux_sym__field_list_repeat1,
  [aux_sym_generic_type_list_repeat1] = aux_sym_generic_type_list_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_function_type_repeat1] = aux_sym_function_type_repeat1,
  [aux_sym_generic_type_repeat1] = aux_sym_generic_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_field_type_repeat1] = aux_sym_field_type_repeat1,
  [aux_sym_if_expression_repeat1] = aux_sym_if_expression_repeat1,
  [aux_sym__binding_list_repeat1] = aux_sym__binding_list_repeat1,
  [aux_sym__interpolated_string_repeat1] = aux_sym__interpolated_string_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__doublequote_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__singlequote_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_buffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_userdata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpolation_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__block_comment_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_comment_end] = {
    .visible = true,
    .named = false,
  },
  [sym__block_string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_chunk] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_varlist] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_explist] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_generic_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_numeric_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__att_name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__attrib] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__quote_string] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__doublequote_string_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__singlequote_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym__block_string] = {
    .visible = false,
    .named = true,
  },
  [sym_vararg_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracket_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_table_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__field_list] = {
    .visible = false,
    .named = true,
  },
  [sym__field_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_update_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__binding_list] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_string] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolation_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_chunk_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_varlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_explist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__att_name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__binding_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpolated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_arguments = 2,
  field_attribute = 3,
  field_body = 4,
  field_clause = 5,
  field_condition = 6,
  field_consequence = 7,
  field_content = 8,
  field_end = 9,
  field_field = 10,
  field_left = 11,
  field_local_declaration = 12,
  field_method = 13,
  field_name = 14,
  field_operand = 15,
  field_parameters = 16,
  field_right = 17,
  field_start = 18,
  field_step = 19,
  field_table = 20,
  field_value = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_clause] = "clause",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_end] = "end",
  [field_field] = "field",
  [field_left] = "left",
  [field_local_declaration] = "local_declaration",
  [field_method] = "method",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_start] = "start",
  [field_step] = "step",
  [field_table] = "table",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 1},
  [5] = {.index = 7, .length = 2},
  [6] = {.index = 9, .length = 3},
  [7] = {.index = 12, .length = 1},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 2},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 2},
  [13] = {.index = 23, .length = 3},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 2},
  [16] = {.index = 30, .length = 1},
  [17] = {.index = 31, .length = 1},
  [18] = {.index = 32, .length = 1},
  [19] = {.index = 33, .length = 1},
  [20] = {.index = 34, .length = 1},
  [21] = {.index = 35, .length = 3},
  [22] = {.index = 38, .length = 2},
  [23] = {.index = 40, .length = 3},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 2},
  [26] = {.index = 47, .length = 2},
  [27] = {.index = 49, .length = 1},
  [28] = {.index = 50, .length = 2},
  [29] = {.index = 52, .length = 1},
  [30] = {.index = 23, .length = 3},
  [31] = {.index = 53, .length = 1},
  [32] = {.index = 54, .length = 2},
  [33] = {.index = 56, .length = 2},
  [34] = {.index = 58, .length = 1},
  [35] = {.index = 59, .length = 2},
  [36] = {.index = 61, .length = 1},
  [37] = {.index = 62, .length = 1},
  [38] = {.index = 63, .length = 1},
  [39] = {.index = 64, .length = 3},
  [40] = {.index = 67, .length = 4},
  [41] = {.index = 71, .length = 4},
  [42] = {.index = 75, .length = 3},
  [43] = {.index = 78, .length = 2},
  [44] = {.index = 80, .length = 2},
  [45] = {.index = 82, .length = 2},
  [46] = {.index = 84, .length = 1},
  [47] = {.index = 85, .length = 2},
  [48] = {.index = 87, .length = 2},
  [49] = {.index = 89, .length = 2},
  [50] = {.index = 91, .length = 2},
  [51] = {.index = 93, .length = 2},
  [52] = {.index = 95, .length = 2},
  [53] = {.index = 97, .length = 2},
  [54] = {.index = 99, .length = 2},
  [55] = {.index = 101, .length = 2},
  [56] = {.index = 103, .length = 3},
  [57] = {.index = 106, .length = 1},
  [58] = {.index = 107, .length = 1},
  [59] = {.index = 108, .length = 2},
  [60] = {.index = 110, .length = 2},
  [61] = {.index = 112, .length = 3},
  [62] = {.index = 115, .length = 3},
  [63] = {.index = 118, .length = 3},
  [64] = {.index = 121, .length = 3},
  [65] = {.index = 124, .length = 4},
  [66] = {.index = 128, .length = 1},
  [67] = {.index = 129, .length = 2},
  [68] = {.index = 131, .length = 2},
  [69] = {.index = 133, .length = 4},
  [70] = {.index = 137, .length = 2},
  [71] = {.index = 139, .length = 2},
  [72] = {.index = 141, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_local_declaration, 0, .inherited = true},
  [1] =
    {field_body, 0, .inherited = true},
    {field_local_declaration, 0},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [5] =
    {field_local_declaration, 0},
  [6] =
    {field_name, 0},
  [7] =
    {field_content, 1},
    {field_start, 0},
  [9] =
    {field_content, 0, .inherited = true},
    {field_end, 0, .inherited = true},
    {field_start, 0, .inherited = true},
  [12] =
    {field_content, 0, .inherited = true},
  [13] =
    {field_field, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [15] =
    {field_method, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [17] =
    {field_attribute, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [23] =
    {field_content, 1},
    {field_end, 2},
    {field_start, 0},
  [26] =
    {field_body, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [28] =
    {field_end, 1},
    {field_start, 0},
  [30] =
    {field_value, 0},
  [31] =
    {field_operand, 1},
  [32] =
    {field_content, 0},
  [33] =
    {field_body, 1},
  [34] =
    {field_condition, 2},
  [35] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
  [38] =
    {field_attribute, 1},
    {field_name, 0},
  [40] =
    {field_attribute, 1, .inherited = true},
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [43] =
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [45] =
    {field_field, 2},
    {field_table, 0},
  [47] =
    {field_method, 2},
    {field_table, 0},
  [49] =
    {field_name, 1},
  [50] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [52] =
    {field_parameters, 0},
  [53] =
    {field_content, 1, .inherited = true},
  [54] =
    {field_content, 0, .inherited = true},
    {field_content, 1, .inherited = true},
  [56] =
    {field_left, 0},
    {field_right, 2},
  [58] =
    {field_condition, 1},
  [59] =
    {field_body, 1},
    {field_condition, 3},
  [61] =
    {field_alternative, 0},
  [62] =
    {field_clause, 1},
  [63] =
    {field_name, 0, .inherited = true},
  [64] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
  [67] =
    {field_attribute, 1},
    {field_attribute, 2, .inherited = true},
    {field_name, 0},
    {field_name, 2, .inherited = true},
  [71] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [75] =
    {field_attribute, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [78] =
    {field_value, 0},
    {field_value, 1, .inherited = true},
  [80] =
    {field_condition, 1},
    {field_consequence, 3},
  [82] =
    {field_body, 1},
    {field_parameters, 0},
  [84] =
    {field_parameters, 1},
  [85] =
    {field_name, 0},
    {field_value, 2},
  [87] =
    {field_body, 3},
    {field_condition, 1},
  [89] =
    {field_alternative, 3},
    {field_condition, 1},
  [91] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 1},
  [93] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [95] =
    {field_name, 0},
    {field_name, 3, .inherited = true},
  [97] =
    {field_body, 3},
    {field_clause, 1},
  [99] =
    {field_attribute, 2},
    {field_name, 1},
  [101] =
    {field_attribute, 3},
    {field_name, 0},
  [103] =
    {field_attribute, 3, .inherited = true},
    {field_name, 0},
    {field_name, 3, .inherited = true},
  [106] =
    {field_name, 2},
  [107] =
    {field_value, 1},
  [108] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [110] =
    {field_body, 2},
    {field_parameters, 1},
  [112] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [115] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [118] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_condition, 1},
  [121] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
  [124] =
    {field_attribute, 3},
    {field_attribute, 4, .inherited = true},
    {field_name, 0},
    {field_name, 4, .inherited = true},
  [128] =
    {field_consequence, 1},
  [129] =
    {field_body, 3},
    {field_parameters, 0},
  [131] =
    {field_name, 1},
    {field_value, 4},
  [133] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [137] =
    {field_attribute, 4},
    {field_name, 1},
  [139] =
    {field_body, 4},
    {field_parameters, 1},
  [141] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
    {field_step, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [30] = {
    [1] = sym__block_string_content,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__doublequote_string_content, 2,
    aux_sym__doublequote_string_content,
    sym__block_string_content,
  aux_sym__singlequote_string_content, 2,
    aux_sym__singlequote_string_content,
    sym__block_string_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 24,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 5,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 19,
  [56] = 18,
  [57] = 20,
  [58] = 22,
  [59] = 21,
  [60] = 23,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 18,
  [77] = 77,
  [78] = 78,
  [79] = 22,
  [80] = 16,
  [81] = 81,
  [82] = 82,
  [83] = 21,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 75,
  [89] = 20,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 23,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 24,
  [100] = 17,
  [101] = 5,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 19,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 117,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 120,
  [124] = 70,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 135,
  [137] = 137,
  [138] = 134,
  [139] = 133,
  [140] = 130,
  [141] = 129,
  [142] = 128,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 146,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 149,
  [180] = 172,
  [181] = 173,
  [182] = 145,
  [183] = 154,
  [184] = 160,
  [185] = 165,
  [186] = 169,
  [187] = 174,
  [188] = 176,
  [189] = 177,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 148,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 316,
  [320] = 320,
  [321] = 316,
  [322] = 318,
  [323] = 318,
  [324] = 318,
  [325] = 316,
  [326] = 6,
  [327] = 327,
  [328] = 328,
  [329] = 13,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 11,
  [335] = 335,
  [336] = 332,
  [337] = 331,
  [338] = 27,
  [339] = 26,
  [340] = 28,
  [341] = 341,
  [342] = 25,
  [343] = 341,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 345,
  [352] = 352,
  [353] = 30,
  [354] = 31,
  [355] = 32,
  [356] = 33,
  [357] = 34,
  [358] = 35,
  [359] = 36,
  [360] = 37,
  [361] = 38,
  [362] = 39,
  [363] = 40,
  [364] = 352,
  [365] = 42,
  [366] = 61,
  [367] = 44,
  [368] = 45,
  [369] = 46,
  [370] = 47,
  [371] = 48,
  [372] = 49,
  [373] = 50,
  [374] = 51,
  [375] = 52,
  [376] = 53,
  [377] = 54,
  [378] = 19,
  [379] = 18,
  [380] = 20,
  [381] = 22,
  [382] = 21,
  [383] = 23,
  [384] = 24,
  [385] = 5,
  [386] = 348,
  [387] = 350,
  [388] = 388,
  [389] = 389,
  [390] = 388,
  [391] = 349,
  [392] = 344,
  [393] = 41,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 429,
  [441] = 434,
  [442] = 442,
  [443] = 443,
  [444] = 435,
  [445] = 439,
  [446] = 446,
  [447] = 431,
  [448] = 438,
  [449] = 429,
  [450] = 434,
  [451] = 435,
  [452] = 439,
  [453] = 453,
  [454] = 429,
  [455] = 434,
  [456] = 435,
  [457] = 439,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 475,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 462,
  [485] = 464,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 481,
  [491] = 479,
  [492] = 459,
  [493] = 493,
  [494] = 493,
  [495] = 472,
  [496] = 496,
  [497] = 482,
  [498] = 483,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 72,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 516,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 528,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 526,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 544,
  [549] = 517,
  [550] = 532,
  [551] = 551,
  [552] = 552,
  [553] = 516,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 516,
  [560] = 560,
  [561] = 561,
  [562] = 541,
  [563] = 510,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 507,
  [572] = 547,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 510,
  [577] = 510,
  [578] = 578,
  [579] = 567,
  [580] = 545,
  [581] = 530,
  [582] = 582,
  [583] = 583,
  [584] = 584,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '"', 62,
        '#', 103,
        '%', 98,
        '&', 121,
        '\'', 63,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 86,
        ',', 44,
        '-', 89,
        '.', 46,
        '/', 93,
        '0', 54,
        ':', 50,
        ';', 41,
        '<', 119,
        '=', 43,
        '>', 53,
        '?', 122,
        '[', 77,
        '\\', 16,
        ']', 78,
        '^', 102,
        '`', 124,
        '{', 79,
        '|', 120,
        '}', 80,
        '~', 14,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(55);
      if (lookahead > ' ' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '"', 62,
        '%', 10,
        '&', 121,
        '\'', 63,
        '(', 75,
        '*', 11,
        '+', 12,
        ',', 44,
        '-', 4,
        '.', 48,
        '/', 9,
        ':', 49,
        '<', 119,
        '=', 42,
        '>', 52,
        '?', 122,
        '[', 77,
        '^', 13,
        '`', 124,
        '{', 79,
        '|', 120,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(62);
      if (lookahead == '-') ADVANCE(65);
      if (lookahead == '\\') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(64);
      if (lookahead != 0) ADVANCE(66);
      END_STATE();
    case 3:
      if (lookahead == '\'') ADVANCE(63);
      if (lookahead == '-') ADVANCE(68);
      if (lookahead == '\\') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(67);
      if (lookahead != 0) ADVANCE(69);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 5:
      if (lookahead == '-') ADVANCE(126);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead == '`') ADVANCE(124);
      if (lookahead == '{') ADVANCE(79);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(125);
      if (lookahead != 0) ADVANCE(127);
      END_STATE();
    case 6:
      if (lookahead == '.') ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(58);
      END_STATE();
    case 7:
      if (lookahead == '.') ADVANCE(74);
      END_STATE();
    case 8:
      if (lookahead == '.') ADVANCE(74);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 9:
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 10:
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 11:
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 15:
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 16:
      if (lookahead == 'U') ADVANCE(73);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'x') ADVANCE(29);
      if (lookahead == '{') ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(72);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(70);
      if (lookahead != 0) ADVANCE(70);
      END_STATE();
    case 17:
      if (lookahead == 'U') ADVANCE(73);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'x') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(72);
      if (lookahead != 0) ADVANCE(70);
      END_STATE();
    case 18:
      if (lookahead == '{') ADVANCE(128);
      END_STATE();
    case 19:
      if (lookahead == '{') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 20:
      if (lookahead == '}') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(61);
      END_STATE();
    case 22:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(60);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(61);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 29:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(32);
      END_STATE();
    case 34:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '"', 62,
        '#', 103,
        '%', 98,
        '&', 121,
        '\'', 63,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 86,
        ',', 44,
        '-', 89,
        '.', 46,
        '/', 93,
        '0', 54,
        ':', 50,
        ';', 41,
        '<', 119,
        '=', 43,
        '>', 53,
        '?', 122,
        '[', 77,
        '\\', 18,
        ']', 78,
        '^', 102,
        '`', 124,
        '{', 79,
        '|', 120,
        '}', 80,
        '~', 14,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(55);
      if (lookahead > ' ' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 35:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '"', 62,
        '#', 103,
        '&', 121,
        '\'', 63,
        '(', 75,
        ')', 76,
        ',', 44,
        '-', 90,
        '.', 6,
        '0', 54,
        ';', 41,
        '<', 119,
        '>', 52,
        '?', 122,
        '[', 77,
        '`', 124,
        '{', 79,
        '|', 120,
        '}', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(55);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 36:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '"', 62,
        '#', 40,
        '%', 98,
        '\'', 63,
        '(', 75,
        ')', 76,
        '*', 92,
        '+', 86,
        ',', 44,
        '-', 88,
        '.', 45,
        '/', 93,
        ':', 50,
        ';', 41,
        '<', 51,
        '=', 43,
        '>', 53,
        '[', 77,
        ']', 78,
        '^', 102,
        '`', 124,
        '{', 79,
        '}', 80,
        '~', 14,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 37:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '"', 62,
        '%', 97,
        '\'', 63,
        '(', 75,
        ')', 76,
        '*', 91,
        '+', 85,
        ',', 44,
        '-', 87,
        '.', 47,
        '/', 94,
        ':', 50,
        ';', 41,
        '<', 51,
        '=', 43,
        '>', 53,
        '[', 77,
        ']', 78,
        '^', 101,
        '`', 124,
        '{', 79,
        '}', 80,
        '~', 14,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 38:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '%', 97,
        '&', 121,
        '(', 75,
        ')', 76,
        '*', 91,
        '+', 85,
        ',', 44,
        '-', 90,
        '.', 47,
        '/', 94,
        ':', 50,
        ';', 41,
        '<', 119,
        '=', 43,
        '>', 53,
        '?', 122,
        ']', 78,
        '^', 101,
        '|', 120,
        '}', 80,
        '~', 14,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(40);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(82);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(100);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(58);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(99);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(8);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(123);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(81);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(22);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(55);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(58);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead == '-') ADVANCE(65);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(66);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead == '-') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead == '-') ADVANCE(68);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(69);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead == '-') ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(69);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(69);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(71);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(109);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(107);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(109);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead == '-') ADVANCE(126);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(125);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_BSLASH_LBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'i', 7,
        'l', 8,
        'n', 9,
        'o', 10,
        'r', 11,
        's', 12,
        't', 13,
        'u', 14,
        'w', 15,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(20);
      END_STATE();
    case 4:
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 'x') ADVANCE(24);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'u') ADVANCE(27);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(29);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'i') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(35);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 12:
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'h') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(40);
      if (lookahead == 'y') ADVANCE(41);
      END_STATE();
    case 14:
      if (lookahead == 'n') ADVANCE(42);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(44);
      END_STATE();
    case 16:
      if (lookahead == 'd') ADVANCE(45);
      if (lookahead == 'y') ADVANCE(46);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(47);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 19:
      if (lookahead == 'f') ADVANCE(49);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(51);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(52);
      END_STATE();
    case 24:
      if (lookahead == 'p') ADVANCE(53);
      END_STATE();
    case 25:
      if (lookahead == 'l') ADVANCE(54);
      END_STATE();
    case 26:
      if (lookahead == 'r') ADVANCE(55);
      END_STATE();
    case 27:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 30:
      if (lookahead == 'c') ADVANCE(57);
      END_STATE();
    case 31:
      if (lookahead == 'v') ADVANCE(58);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(59);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(61);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(62);
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 38:
      if (lookahead == 'b') ADVANCE(65);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 40:
      if (lookahead == 'u') ADVANCE(68);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 42:
      if (lookahead == 'k') ADVANCE(70);
      if (lookahead == 't') ADVANCE(71);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 49:
      if (lookahead == 'f') ADVANCE(76);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 53:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 56:
      if (lookahead == 'c') ADVANCE(81);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 61:
      if (lookahead == 'b') ADVANCE(84);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(87);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 66:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 73:
      if (lookahead == 'l') ADVANCE(96);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 75:
      if (lookahead == 'k') ADVANCE(98);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(100);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(101);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(102);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(105);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(109);
      END_STATE();
    case 87:
      if (lookahead == 'n') ADVANCE(110);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(112);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(113);
      END_STATE();
    case 93:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(115);
      END_STATE();
    case 95:
      if (lookahead == 'd') ADVANCE(116);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(118);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 99:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 100:
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 101:
      if (lookahead == 'f') ADVANCE(121);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 104:
      if (lookahead == 'i') ADVANCE(123);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 109:
      if (lookahead == 'n') ADVANCE(126);
      END_STATE();
    case 110:
      if (lookahead == 'g') ADVANCE(127);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_table);
      END_STATE();
    case 112:
      if (lookahead == 'd') ADVANCE(128);
      END_STATE();
    case 113:
      if (lookahead == 'f') ADVANCE(129);
      END_STATE();
    case 114:
      if (lookahead == 'w') ADVANCE(130);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 118:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_buffer);
      END_STATE();
    case 120:
      if (lookahead == 'u') ADVANCE(133);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(134);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_thread);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 134:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 136:
      if (lookahead == 'a') ADVANCE(139);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_userdata);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 36, .external_lex_state = 2},
  [2] = {.lex_state = 36, .external_lex_state = 3},
  [3] = {.lex_state = 36, .external_lex_state = 3},
  [4] = {.lex_state = 36, .external_lex_state = 3},
  [5] = {.lex_state = 37, .external_lex_state = 3},
  [6] = {.lex_state = 38, .external_lex_state = 2},
  [7] = {.lex_state = 37, .external_lex_state = 3},
  [8] = {.lex_state = 37, .external_lex_state = 3},
  [9] = {.lex_state = 37, .external_lex_state = 3},
  [10] = {.lex_state = 37, .external_lex_state = 3},
  [11] = {.lex_state = 38, .external_lex_state = 2},
  [12] = {.lex_state = 37, .external_lex_state = 3},
  [13] = {.lex_state = 38, .external_lex_state = 2},
  [14] = {.lex_state = 37, .external_lex_state = 3},
  [15] = {.lex_state = 37, .external_lex_state = 3},
  [16] = {.lex_state = 37, .external_lex_state = 3},
  [17] = {.lex_state = 37, .external_lex_state = 3},
  [18] = {.lex_state = 37, .external_lex_state = 3},
  [19] = {.lex_state = 37, .external_lex_state = 3},
  [20] = {.lex_state = 37, .external_lex_state = 3},
  [21] = {.lex_state = 37, .external_lex_state = 3},
  [22] = {.lex_state = 37, .external_lex_state = 3},
  [23] = {.lex_state = 37, .external_lex_state = 3},
  [24] = {.lex_state = 37, .external_lex_state = 3},
  [25] = {.lex_state = 38, .external_lex_state = 2},
  [26] = {.lex_state = 38, .external_lex_state = 2},
  [27] = {.lex_state = 38, .external_lex_state = 2},
  [28] = {.lex_state = 38, .external_lex_state = 2},
  [29] = {.lex_state = 38, .external_lex_state = 2},
  [30] = {.lex_state = 38, .external_lex_state = 2},
  [31] = {.lex_state = 38, .external_lex_state = 2},
  [32] = {.lex_state = 38, .external_lex_state = 2},
  [33] = {.lex_state = 38, .external_lex_state = 2},
  [34] = {.lex_state = 38, .external_lex_state = 2},
  [35] = {.lex_state = 38, .external_lex_state = 2},
  [36] = {.lex_state = 38, .external_lex_state = 2},
  [37] = {.lex_state = 38, .external_lex_state = 2},
  [38] = {.lex_state = 38, .external_lex_state = 2},
  [39] = {.lex_state = 38, .external_lex_state = 2},
  [40] = {.lex_state = 38, .external_lex_state = 2},
  [41] = {.lex_state = 38, .external_lex_state = 2},
  [42] = {.lex_state = 38, .external_lex_state = 2},
  [43] = {.lex_state = 38, .external_lex_state = 2},
  [44] = {.lex_state = 38, .external_lex_state = 2},
  [45] = {.lex_state = 38, .external_lex_state = 2},
  [46] = {.lex_state = 38, .external_lex_state = 2},
  [47] = {.lex_state = 38, .external_lex_state = 2},
  [48] = {.lex_state = 38, .external_lex_state = 2},
  [49] = {.lex_state = 38, .external_lex_state = 2},
  [50] = {.lex_state = 38, .external_lex_state = 2},
  [51] = {.lex_state = 38, .external_lex_state = 2},
  [52] = {.lex_state = 38, .external_lex_state = 2},
  [53] = {.lex_state = 38, .external_lex_state = 2},
  [54] = {.lex_state = 38, .external_lex_state = 2},
  [55] = {.lex_state = 38, .external_lex_state = 2},
  [56] = {.lex_state = 38, .external_lex_state = 2},
  [57] = {.lex_state = 38, .external_lex_state = 2},
  [58] = {.lex_state = 38, .external_lex_state = 2},
  [59] = {.lex_state = 38, .external_lex_state = 2},
  [60] = {.lex_state = 38, .external_lex_state = 2},
  [61] = {.lex_state = 38, .external_lex_state = 2},
  [62] = {.lex_state = 38, .external_lex_state = 2},
  [63] = {.lex_state = 0, .external_lex_state = 2},
  [64] = {.lex_state = 37, .external_lex_state = 2},
  [65] = {.lex_state = 0, .external_lex_state = 2},
  [66] = {.lex_state = 0, .external_lex_state = 2},
  [67] = {.lex_state = 37, .external_lex_state = 2},
  [68] = {.lex_state = 37, .external_lex_state = 2},
  [69] = {.lex_state = 0, .external_lex_state = 2},
  [70] = {.lex_state = 35, .external_lex_state = 3},
  [71] = {.lex_state = 0, .external_lex_state = 2},
  [72] = {.lex_state = 37, .external_lex_state = 2},
  [73] = {.lex_state = 0, .external_lex_state = 2},
  [74] = {.lex_state = 37, .external_lex_state = 2},
  [75] = {.lex_state = 35, .external_lex_state = 3},
  [76] = {.lex_state = 37, .external_lex_state = 2},
  [77] = {.lex_state = 37, .external_lex_state = 2},
  [78] = {.lex_state = 0, .external_lex_state = 2},
  [79] = {.lex_state = 37, .external_lex_state = 2},
  [80] = {.lex_state = 37, .external_lex_state = 2},
  [81] = {.lex_state = 37, .external_lex_state = 2},
  [82] = {.lex_state = 37, .external_lex_state = 2},
  [83] = {.lex_state = 37, .external_lex_state = 2},
  [84] = {.lex_state = 37, .external_lex_state = 2},
  [85] = {.lex_state = 37, .external_lex_state = 2},
  [86] = {.lex_state = 37, .external_lex_state = 2},
  [87] = {.lex_state = 37, .external_lex_state = 2},
  [88] = {.lex_state = 35, .external_lex_state = 3},
  [89] = {.lex_state = 37, .external_lex_state = 2},
  [90] = {.lex_state = 37, .external_lex_state = 2},
  [91] = {.lex_state = 37, .external_lex_state = 2},
  [92] = {.lex_state = 37, .external_lex_state = 2},
  [93] = {.lex_state = 37, .external_lex_state = 2},
  [94] = {.lex_state = 37, .external_lex_state = 2},
  [95] = {.lex_state = 37, .external_lex_state = 2},
  [96] = {.lex_state = 37, .external_lex_state = 2},
  [97] = {.lex_state = 37, .external_lex_state = 2},
  [98] = {.lex_state = 0, .external_lex_state = 2},
  [99] = {.lex_state = 37, .external_lex_state = 2},
  [100] = {.lex_state = 37, .external_lex_state = 2},
  [101] = {.lex_state = 37, .external_lex_state = 2},
  [102] = {.lex_state = 37, .external_lex_state = 2},
  [103] = {.lex_state = 37, .external_lex_state = 2},
  [104] = {.lex_state = 37, .external_lex_state = 2},
  [105] = {.lex_state = 37, .external_lex_state = 2},
  [106] = {.lex_state = 37, .external_lex_state = 2},
  [107] = {.lex_state = 37, .external_lex_state = 2},
  [108] = {.lex_state = 37, .external_lex_state = 2},
  [109] = {.lex_state = 37, .external_lex_state = 2},
  [110] = {.lex_state = 37, .external_lex_state = 2},
  [111] = {.lex_state = 37, .external_lex_state = 2},
  [112] = {.lex_state = 0, .external_lex_state = 2},
  [113] = {.lex_state = 0, .external_lex_state = 2},
  [114] = {.lex_state = 0, .external_lex_state = 2},
  [115] = {.lex_state = 0, .external_lex_state = 2},
  [116] = {.lex_state = 0, .external_lex_state = 2},
  [117] = {.lex_state = 35, .external_lex_state = 3},
  [118] = {.lex_state = 35, .external_lex_state = 3},
  [119] = {.lex_state = 35, .external_lex_state = 3},
  [120] = {.lex_state = 35, .external_lex_state = 3},
  [121] = {.lex_state = 35, .external_lex_state = 3},
  [122] = {.lex_state = 0, .external_lex_state = 2},
  [123] = {.lex_state = 35, .external_lex_state = 3},
  [124] = {.lex_state = 35, .external_lex_state = 3},
  [125] = {.lex_state = 0, .external_lex_state = 2},
  [126] = {.lex_state = 0, .external_lex_state = 2},
  [127] = {.lex_state = 35, .external_lex_state = 3},
  [128] = {.lex_state = 35, .external_lex_state = 3},
  [129] = {.lex_state = 35, .external_lex_state = 3},
  [130] = {.lex_state = 35, .external_lex_state = 3},
  [131] = {.lex_state = 35, .external_lex_state = 3},
  [132] = {.lex_state = 35, .external_lex_state = 3},
  [133] = {.lex_state = 35, .external_lex_state = 3},
  [134] = {.lex_state = 35, .external_lex_state = 3},
  [135] = {.lex_state = 35, .external_lex_state = 3},
  [136] = {.lex_state = 35, .external_lex_state = 3},
  [137] = {.lex_state = 37, .external_lex_state = 2},
  [138] = {.lex_state = 35, .external_lex_state = 3},
  [139] = {.lex_state = 35, .external_lex_state = 3},
  [140] = {.lex_state = 35, .external_lex_state = 3},
  [141] = {.lex_state = 35, .external_lex_state = 3},
  [142] = {.lex_state = 35, .external_lex_state = 3},
  [143] = {.lex_state = 35, .external_lex_state = 3},
  [144] = {.lex_state = 35, .external_lex_state = 3},
  [145] = {.lex_state = 35, .external_lex_state = 3},
  [146] = {.lex_state = 35, .external_lex_state = 3},
  [147] = {.lex_state = 35, .external_lex_state = 3},
  [148] = {.lex_state = 35, .external_lex_state = 3},
  [149] = {.lex_state = 35, .external_lex_state = 3},
  [150] = {.lex_state = 35, .external_lex_state = 3},
  [151] = {.lex_state = 35, .external_lex_state = 3},
  [152] = {.lex_state = 35, .external_lex_state = 3},
  [153] = {.lex_state = 35, .external_lex_state = 3},
  [154] = {.lex_state = 35, .external_lex_state = 3},
  [155] = {.lex_state = 35, .external_lex_state = 3},
  [156] = {.lex_state = 35, .external_lex_state = 3},
  [157] = {.lex_state = 37, .external_lex_state = 2},
  [158] = {.lex_state = 35, .external_lex_state = 3},
  [159] = {.lex_state = 35, .external_lex_state = 3},
  [160] = {.lex_state = 35, .external_lex_state = 3},
  [161] = {.lex_state = 35, .external_lex_state = 3},
  [162] = {.lex_state = 35, .external_lex_state = 3},
  [163] = {.lex_state = 35, .external_lex_state = 3},
  [164] = {.lex_state = 35, .external_lex_state = 3},
  [165] = {.lex_state = 35, .external_lex_state = 3},
  [166] = {.lex_state = 35, .external_lex_state = 3},
  [167] = {.lex_state = 35, .external_lex_state = 3},
  [168] = {.lex_state = 35, .external_lex_state = 3},
  [169] = {.lex_state = 35, .external_lex_state = 3},
  [170] = {.lex_state = 35, .external_lex_state = 3},
  [171] = {.lex_state = 35, .external_lex_state = 3},
  [172] = {.lex_state = 35, .external_lex_state = 3},
  [173] = {.lex_state = 35, .external_lex_state = 3},
  [174] = {.lex_state = 35, .external_lex_state = 3},
  [175] = {.lex_state = 35, .external_lex_state = 3},
  [176] = {.lex_state = 35, .external_lex_state = 3},
  [177] = {.lex_state = 35, .external_lex_state = 3},
  [178] = {.lex_state = 35, .external_lex_state = 3},
  [179] = {.lex_state = 35, .external_lex_state = 3},
  [180] = {.lex_state = 35, .external_lex_state = 3},
  [181] = {.lex_state = 35, .external_lex_state = 3},
  [182] = {.lex_state = 35, .external_lex_state = 3},
  [183] = {.lex_state = 35, .external_lex_state = 3},
  [184] = {.lex_state = 35, .external_lex_state = 3},
  [185] = {.lex_state = 35, .external_lex_state = 3},
  [186] = {.lex_state = 35, .external_lex_state = 3},
  [187] = {.lex_state = 35, .external_lex_state = 3},
  [188] = {.lex_state = 35, .external_lex_state = 3},
  [189] = {.lex_state = 35, .external_lex_state = 3},
  [190] = {.lex_state = 35, .external_lex_state = 3},
  [191] = {.lex_state = 35, .external_lex_state = 3},
  [192] = {.lex_state = 35, .external_lex_state = 3},
  [193] = {.lex_state = 35, .external_lex_state = 3},
  [194] = {.lex_state = 35, .external_lex_state = 3},
  [195] = {.lex_state = 35, .external_lex_state = 3},
  [196] = {.lex_state = 35, .external_lex_state = 3},
  [197] = {.lex_state = 35, .external_lex_state = 3},
  [198] = {.lex_state = 35, .external_lex_state = 3},
  [199] = {.lex_state = 35, .external_lex_state = 3},
  [200] = {.lex_state = 37, .external_lex_state = 2},
  [201] = {.lex_state = 35, .external_lex_state = 3},
  [202] = {.lex_state = 35, .external_lex_state = 3},
  [203] = {.lex_state = 35, .external_lex_state = 3},
  [204] = {.lex_state = 35, .external_lex_state = 3},
  [205] = {.lex_state = 35, .external_lex_state = 3},
  [206] = {.lex_state = 35, .external_lex_state = 3},
  [207] = {.lex_state = 35, .external_lex_state = 3},
  [208] = {.lex_state = 35, .external_lex_state = 3},
  [209] = {.lex_state = 35, .external_lex_state = 3},
  [210] = {.lex_state = 35, .external_lex_state = 3},
  [211] = {.lex_state = 35, .external_lex_state = 3},
  [212] = {.lex_state = 35, .external_lex_state = 3},
  [213] = {.lex_state = 35, .external_lex_state = 3},
  [214] = {.lex_state = 35, .external_lex_state = 3},
  [215] = {.lex_state = 35, .external_lex_state = 3},
  [216] = {.lex_state = 35, .external_lex_state = 3},
  [217] = {.lex_state = 35, .external_lex_state = 3},
  [218] = {.lex_state = 35, .external_lex_state = 3},
  [219] = {.lex_state = 35, .external_lex_state = 3},
  [220] = {.lex_state = 37, .external_lex_state = 2},
  [221] = {.lex_state = 35, .external_lex_state = 3},
  [222] = {.lex_state = 35, .external_lex_state = 3},
  [223] = {.lex_state = 35, .external_lex_state = 3},
  [224] = {.lex_state = 35, .external_lex_state = 3},
  [225] = {.lex_state = 35, .external_lex_state = 3},
  [226] = {.lex_state = 35, .external_lex_state = 3},
  [227] = {.lex_state = 35, .external_lex_state = 3},
  [228] = {.lex_state = 35, .external_lex_state = 3},
  [229] = {.lex_state = 35, .external_lex_state = 3},
  [230] = {.lex_state = 37, .external_lex_state = 3},
  [231] = {.lex_state = 0, .external_lex_state = 2},
  [232] = {.lex_state = 36, .external_lex_state = 3},
  [233] = {.lex_state = 0, .external_lex_state = 2},
  [234] = {.lex_state = 37, .external_lex_state = 2},
  [235] = {.lex_state = 36, .external_lex_state = 2},
  [236] = {.lex_state = 37, .external_lex_state = 2},
  [237] = {.lex_state = 36, .external_lex_state = 2},
  [238] = {.lex_state = 0, .external_lex_state = 2},
  [239] = {.lex_state = 0, .external_lex_state = 2},
  [240] = {.lex_state = 0, .external_lex_state = 2},
  [241] = {.lex_state = 0, .external_lex_state = 2},
  [242] = {.lex_state = 0, .external_lex_state = 2},
  [243] = {.lex_state = 0, .external_lex_state = 2},
  [244] = {.lex_state = 0, .external_lex_state = 2},
  [245] = {.lex_state = 0, .external_lex_state = 2},
  [246] = {.lex_state = 0, .external_lex_state = 2},
  [247] = {.lex_state = 0, .external_lex_state = 2},
  [248] = {.lex_state = 0, .external_lex_state = 2},
  [249] = {.lex_state = 0, .external_lex_state = 2},
  [250] = {.lex_state = 0, .external_lex_state = 2},
  [251] = {.lex_state = 0, .external_lex_state = 2},
  [252] = {.lex_state = 0, .external_lex_state = 2},
  [253] = {.lex_state = 37, .external_lex_state = 2},
  [254] = {.lex_state = 0, .external_lex_state = 2},
  [255] = {.lex_state = 0, .external_lex_state = 2},
  [256] = {.lex_state = 37, .external_lex_state = 2},
  [257] = {.lex_state = 0, .external_lex_state = 2},
  [258] = {.lex_state = 0, .external_lex_state = 2},
  [259] = {.lex_state = 0, .external_lex_state = 2},
  [260] = {.lex_state = 0, .external_lex_state = 2},
  [261] = {.lex_state = 0, .external_lex_state = 2},
  [262] = {.lex_state = 0, .external_lex_state = 2},
  [263] = {.lex_state = 0, .external_lex_state = 2},
  [264] = {.lex_state = 0, .external_lex_state = 2},
  [265] = {.lex_state = 37, .external_lex_state = 2},
  [266] = {.lex_state = 0, .external_lex_state = 2},
  [267] = {.lex_state = 0, .external_lex_state = 2},
  [268] = {.lex_state = 0, .external_lex_state = 2},
  [269] = {.lex_state = 0, .external_lex_state = 2},
  [270] = {.lex_state = 1, .external_lex_state = 3},
  [271] = {.lex_state = 0, .external_lex_state = 2},
  [272] = {.lex_state = 0, .external_lex_state = 2},
  [273] = {.lex_state = 0, .external_lex_state = 2},
  [274] = {.lex_state = 0, .external_lex_state = 2},
  [275] = {.lex_state = 0, .external_lex_state = 2},
  [276] = {.lex_state = 0, .external_lex_state = 2},
  [277] = {.lex_state = 0, .external_lex_state = 2},
  [278] = {.lex_state = 0, .external_lex_state = 2},
  [279] = {.lex_state = 0, .external_lex_state = 2},
  [280] = {.lex_state = 0, .external_lex_state = 2},
  [281] = {.lex_state = 0, .external_lex_state = 2},
  [282] = {.lex_state = 0, .external_lex_state = 2},
  [283] = {.lex_state = 0, .external_lex_state = 2},
  [284] = {.lex_state = 0, .external_lex_state = 2},
  [285] = {.lex_state = 0, .external_lex_state = 2},
  [286] = {.lex_state = 0, .external_lex_state = 2},
  [287] = {.lex_state = 0, .external_lex_state = 2},
  [288] = {.lex_state = 37, .external_lex_state = 2},
  [289] = {.lex_state = 0, .external_lex_state = 2},
  [290] = {.lex_state = 0, .external_lex_state = 2},
  [291] = {.lex_state = 0, .external_lex_state = 2},
  [292] = {.lex_state = 0, .external_lex_state = 2},
  [293] = {.lex_state = 0, .external_lex_state = 2},
  [294] = {.lex_state = 37, .external_lex_state = 2},
  [295] = {.lex_state = 1, .external_lex_state = 3},
  [296] = {.lex_state = 35, .external_lex_state = 3},
  [297] = {.lex_state = 37, .external_lex_state = 2},
  [298] = {.lex_state = 37, .external_lex_state = 2},
  [299] = {.lex_state = 37, .external_lex_state = 2},
  [300] = {.lex_state = 37, .external_lex_state = 2},
  [301] = {.lex_state = 37, .external_lex_state = 2},
  [302] = {.lex_state = 37, .external_lex_state = 2},
  [303] = {.lex_state = 37, .external_lex_state = 2},
  [304] = {.lex_state = 37, .external_lex_state = 2},
  [305] = {.lex_state = 37, .external_lex_state = 2},
  [306] = {.lex_state = 37, .external_lex_state = 2},
  [307] = {.lex_state = 37, .external_lex_state = 2},
  [308] = {.lex_state = 37, .external_lex_state = 2},
  [309] = {.lex_state = 37, .external_lex_state = 2},
  [310] = {.lex_state = 0, .external_lex_state = 2},
  [311] = {.lex_state = 0, .external_lex_state = 2},
  [312] = {.lex_state = 36, .external_lex_state = 3},
  [313] = {.lex_state = 0, .external_lex_state = 3},
  [314] = {.lex_state = 1, .external_lex_state = 2},
  [315] = {.lex_state = 1, .external_lex_state = 2},
  [316] = {.lex_state = 5, .external_lex_state = 2},
  [317] = {.lex_state = 0, .external_lex_state = 2},
  [318] = {.lex_state = 5, .external_lex_state = 2},
  [319] = {.lex_state = 5, .external_lex_state = 2},
  [320] = {.lex_state = 5, .external_lex_state = 2},
  [321] = {.lex_state = 5, .external_lex_state = 2},
  [322] = {.lex_state = 5, .external_lex_state = 2},
  [323] = {.lex_state = 5, .external_lex_state = 2},
  [324] = {.lex_state = 5, .external_lex_state = 2},
  [325] = {.lex_state = 5, .external_lex_state = 2},
  [326] = {.lex_state = 1, .external_lex_state = 2},
  [327] = {.lex_state = 0, .external_lex_state = 2},
  [328] = {.lex_state = 36, .external_lex_state = 3},
  [329] = {.lex_state = 1, .external_lex_state = 2},
  [330] = {.lex_state = 38, .external_lex_state = 2},
  [331] = {.lex_state = 38, .external_lex_state = 2},
  [332] = {.lex_state = 38, .external_lex_state = 2},
  [333] = {.lex_state = 1, .external_lex_state = 2},
  [334] = {.lex_state = 1, .external_lex_state = 2},
  [335] = {.lex_state = 0, .external_lex_state = 2},
  [336] = {.lex_state = 38, .external_lex_state = 2},
  [337] = {.lex_state = 38, .external_lex_state = 2},
  [338] = {.lex_state = 1, .external_lex_state = 2},
  [339] = {.lex_state = 35, .external_lex_state = 2},
  [340] = {.lex_state = 35, .external_lex_state = 2},
  [341] = {.lex_state = 35, .external_lex_state = 2},
  [342] = {.lex_state = 35, .external_lex_state = 2},
  [343] = {.lex_state = 35, .external_lex_state = 2},
  [344] = {.lex_state = 0, .external_lex_state = 2},
  [345] = {.lex_state = 0, .external_lex_state = 2},
  [346] = {.lex_state = 0, .external_lex_state = 2},
  [347] = {.lex_state = 35, .external_lex_state = 2},
  [348] = {.lex_state = 0, .external_lex_state = 2},
  [349] = {.lex_state = 0, .external_lex_state = 2},
  [350] = {.lex_state = 0, .external_lex_state = 2},
  [351] = {.lex_state = 0, .external_lex_state = 2},
  [352] = {.lex_state = 0, .external_lex_state = 2},
  [353] = {.lex_state = 35, .external_lex_state = 2},
  [354] = {.lex_state = 35, .external_lex_state = 2},
  [355] = {.lex_state = 35, .external_lex_state = 2},
  [356] = {.lex_state = 35, .external_lex_state = 2},
  [357] = {.lex_state = 35, .external_lex_state = 2},
  [358] = {.lex_state = 35, .external_lex_state = 2},
  [359] = {.lex_state = 35, .external_lex_state = 2},
  [360] = {.lex_state = 35, .external_lex_state = 2},
  [361] = {.lex_state = 35, .external_lex_state = 2},
  [362] = {.lex_state = 35, .external_lex_state = 2},
  [363] = {.lex_state = 35, .external_lex_state = 2},
  [364] = {.lex_state = 0, .external_lex_state = 2},
  [365] = {.lex_state = 35, .external_lex_state = 2},
  [366] = {.lex_state = 35, .external_lex_state = 2},
  [367] = {.lex_state = 35, .external_lex_state = 2},
  [368] = {.lex_state = 35, .external_lex_state = 2},
  [369] = {.lex_state = 35, .external_lex_state = 2},
  [370] = {.lex_state = 35, .external_lex_state = 2},
  [371] = {.lex_state = 35, .external_lex_state = 2},
  [372] = {.lex_state = 35, .external_lex_state = 2},
  [373] = {.lex_state = 35, .external_lex_state = 2},
  [374] = {.lex_state = 35, .external_lex_state = 2},
  [375] = {.lex_state = 35, .external_lex_state = 2},
  [376] = {.lex_state = 35, .external_lex_state = 2},
  [377] = {.lex_state = 35, .external_lex_state = 2},
  [378] = {.lex_state = 35, .external_lex_state = 2},
  [379] = {.lex_state = 35, .external_lex_state = 2},
  [380] = {.lex_state = 35, .external_lex_state = 2},
  [381] = {.lex_state = 35, .external_lex_state = 2},
  [382] = {.lex_state = 35, .external_lex_state = 2},
  [383] = {.lex_state = 35, .external_lex_state = 2},
  [384] = {.lex_state = 35, .external_lex_state = 2},
  [385] = {.lex_state = 35, .external_lex_state = 2},
  [386] = {.lex_state = 0, .external_lex_state = 2},
  [387] = {.lex_state = 0, .external_lex_state = 2},
  [388] = {.lex_state = 0, .external_lex_state = 2},
  [389] = {.lex_state = 0, .external_lex_state = 2},
  [390] = {.lex_state = 0, .external_lex_state = 2},
  [391] = {.lex_state = 0, .external_lex_state = 2},
  [392] = {.lex_state = 0, .external_lex_state = 2},
  [393] = {.lex_state = 35, .external_lex_state = 2},
  [394] = {.lex_state = 0, .external_lex_state = 2},
  [395] = {.lex_state = 0, .external_lex_state = 2},
  [396] = {.lex_state = 0, .external_lex_state = 2},
  [397] = {.lex_state = 0, .external_lex_state = 3},
  [398] = {.lex_state = 0, .external_lex_state = 2},
  [399] = {.lex_state = 35, .external_lex_state = 2},
  [400] = {.lex_state = 5, .external_lex_state = 2},
  [401] = {.lex_state = 0, .external_lex_state = 2},
  [402] = {.lex_state = 5, .external_lex_state = 2},
  [403] = {.lex_state = 0, .external_lex_state = 2},
  [404] = {.lex_state = 0, .external_lex_state = 2},
  [405] = {.lex_state = 5, .external_lex_state = 2},
  [406] = {.lex_state = 5, .external_lex_state = 2},
  [407] = {.lex_state = 0, .external_lex_state = 2},
  [408] = {.lex_state = 5, .external_lex_state = 2},
  [409] = {.lex_state = 5, .external_lex_state = 2},
  [410] = {.lex_state = 36, .external_lex_state = 2},
  [411] = {.lex_state = 0, .external_lex_state = 2},
  [412] = {.lex_state = 0, .external_lex_state = 2},
  [413] = {.lex_state = 0, .external_lex_state = 2},
  [414] = {.lex_state = 0, .external_lex_state = 2},
  [415] = {.lex_state = 0, .external_lex_state = 2},
  [416] = {.lex_state = 0, .external_lex_state = 2},
  [417] = {.lex_state = 0, .external_lex_state = 2},
  [418] = {.lex_state = 0, .external_lex_state = 2},
  [419] = {.lex_state = 0, .external_lex_state = 2},
  [420] = {.lex_state = 35, .external_lex_state = 2},
  [421] = {.lex_state = 36, .external_lex_state = 2},
  [422] = {.lex_state = 0, .external_lex_state = 2},
  [423] = {.lex_state = 0, .external_lex_state = 2},
  [424] = {.lex_state = 36, .external_lex_state = 2},
  [425] = {.lex_state = 36, .external_lex_state = 2},
  [426] = {.lex_state = 36, .external_lex_state = 2},
  [427] = {.lex_state = 35, .external_lex_state = 2},
  [428] = {.lex_state = 35, .external_lex_state = 2},
  [429] = {.lex_state = 2, .external_lex_state = 2},
  [430] = {.lex_state = 0, .external_lex_state = 2},
  [431] = {.lex_state = 0, .external_lex_state = 2},
  [432] = {.lex_state = 0, .external_lex_state = 2},
  [433] = {.lex_state = 36, .external_lex_state = 2},
  [434] = {.lex_state = 3, .external_lex_state = 2},
  [435] = {.lex_state = 2, .external_lex_state = 2},
  [436] = {.lex_state = 2, .external_lex_state = 2},
  [437] = {.lex_state = 36, .external_lex_state = 2},
  [438] = {.lex_state = 0, .external_lex_state = 2},
  [439] = {.lex_state = 3, .external_lex_state = 2},
  [440] = {.lex_state = 2, .external_lex_state = 2},
  [441] = {.lex_state = 3, .external_lex_state = 2},
  [442] = {.lex_state = 3, .external_lex_state = 2},
  [443] = {.lex_state = 0, .external_lex_state = 2},
  [444] = {.lex_state = 2, .external_lex_state = 2},
  [445] = {.lex_state = 3, .external_lex_state = 2},
  [446] = {.lex_state = 0, .external_lex_state = 2},
  [447] = {.lex_state = 0, .external_lex_state = 2},
  [448] = {.lex_state = 0, .external_lex_state = 2},
  [449] = {.lex_state = 2, .external_lex_state = 2},
  [450] = {.lex_state = 3, .external_lex_state = 2},
  [451] = {.lex_state = 2, .external_lex_state = 2},
  [452] = {.lex_state = 3, .external_lex_state = 2},
  [453] = {.lex_state = 0, .external_lex_state = 2},
  [454] = {.lex_state = 2, .external_lex_state = 2},
  [455] = {.lex_state = 3, .external_lex_state = 2},
  [456] = {.lex_state = 2, .external_lex_state = 2},
  [457] = {.lex_state = 3, .external_lex_state = 2},
  [458] = {.lex_state = 3, .external_lex_state = 2},
  [459] = {.lex_state = 0, .external_lex_state = 2},
  [460] = {.lex_state = 0, .external_lex_state = 2},
  [461] = {.lex_state = 0, .external_lex_state = 2},
  [462] = {.lex_state = 0, .external_lex_state = 2},
  [463] = {.lex_state = 35, .external_lex_state = 2},
  [464] = {.lex_state = 35, .external_lex_state = 2},
  [465] = {.lex_state = 35, .external_lex_state = 2},
  [466] = {.lex_state = 35, .external_lex_state = 2},
  [467] = {.lex_state = 0, .external_lex_state = 2},
  [468] = {.lex_state = 0, .external_lex_state = 2},
  [469] = {.lex_state = 2, .external_lex_state = 2},
  [470] = {.lex_state = 0, .external_lex_state = 2},
  [471] = {.lex_state = 0, .external_lex_state = 2},
  [472] = {.lex_state = 0, .external_lex_state = 2},
  [473] = {.lex_state = 0, .external_lex_state = 2},
  [474] = {.lex_state = 0, .external_lex_state = 2},
  [475] = {.lex_state = 0, .external_lex_state = 2},
  [476] = {.lex_state = 0, .external_lex_state = 2},
  [477] = {.lex_state = 0, .external_lex_state = 2},
  [478] = {.lex_state = 0, .external_lex_state = 2},
  [479] = {.lex_state = 0, .external_lex_state = 2},
  [480] = {.lex_state = 0, .external_lex_state = 2},
  [481] = {.lex_state = 0, .external_lex_state = 2},
  [482] = {.lex_state = 35, .external_lex_state = 2},
  [483] = {.lex_state = 35, .external_lex_state = 2},
  [484] = {.lex_state = 0, .external_lex_state = 2},
  [485] = {.lex_state = 35, .external_lex_state = 2},
  [486] = {.lex_state = 35, .external_lex_state = 2},
  [487] = {.lex_state = 35, .external_lex_state = 2},
  [488] = {.lex_state = 0, .external_lex_state = 2},
  [489] = {.lex_state = 0, .external_lex_state = 2},
  [490] = {.lex_state = 0, .external_lex_state = 2},
  [491] = {.lex_state = 0, .external_lex_state = 2},
  [492] = {.lex_state = 0, .external_lex_state = 2},
  [493] = {.lex_state = 0, .external_lex_state = 2},
  [494] = {.lex_state = 0, .external_lex_state = 2},
  [495] = {.lex_state = 0, .external_lex_state = 2},
  [496] = {.lex_state = 0, .external_lex_state = 2},
  [497] = {.lex_state = 35, .external_lex_state = 2},
  [498] = {.lex_state = 35, .external_lex_state = 2},
  [499] = {.lex_state = 0, .external_lex_state = 2},
  [500] = {.lex_state = 36, .external_lex_state = 2},
  [501] = {.lex_state = 35, .external_lex_state = 2},
  [502] = {.lex_state = 36, .external_lex_state = 2},
  [503] = {.lex_state = 35, .external_lex_state = 2},
  [504] = {.lex_state = 0, .external_lex_state = 2},
  [505] = {.lex_state = 0, .external_lex_state = 2},
  [506] = {.lex_state = 35, .external_lex_state = 2},
  [507] = {.lex_state = 0, .external_lex_state = 2},
  [508] = {.lex_state = 0, .external_lex_state = 2},
  [509] = {.lex_state = 0, .external_lex_state = 2},
  [510] = {.lex_state = 0, .external_lex_state = 4},
  [511] = {.lex_state = 0, .external_lex_state = 2},
  [512] = {.lex_state = 0, .external_lex_state = 2},
  [513] = {.lex_state = 0, .external_lex_state = 2},
  [514] = {.lex_state = 0, .external_lex_state = 5},
  [515] = {.lex_state = 0, .external_lex_state = 2},
  [516] = {.lex_state = 0, .external_lex_state = 6},
  [517] = {.lex_state = 0, .external_lex_state = 2},
  [518] = {.lex_state = 0, .external_lex_state = 2},
  [519] = {.lex_state = 0, .external_lex_state = 2},
  [520] = {.lex_state = 0, .external_lex_state = 2},
  [521] = {.lex_state = 0, .external_lex_state = 2},
  [522] = {.lex_state = 0, .external_lex_state = 6},
  [523] = {.lex_state = 0, .external_lex_state = 2},
  [524] = {.lex_state = 0, .external_lex_state = 2},
  [525] = {.lex_state = 0, .external_lex_state = 2},
  [526] = {.lex_state = 0, .external_lex_state = 2},
  [527] = {.lex_state = 0, .external_lex_state = 2},
  [528] = {.lex_state = 0, .external_lex_state = 2},
  [529] = {.lex_state = 0, .external_lex_state = 2},
  [530] = {.lex_state = 0, .external_lex_state = 2},
  [531] = {.lex_state = 35, .external_lex_state = 2},
  [532] = {.lex_state = 0, .external_lex_state = 2},
  [533] = {.lex_state = 0, .external_lex_state = 2},
  [534] = {.lex_state = 0, .external_lex_state = 2},
  [535] = {.lex_state = 0, .external_lex_state = 2},
  [536] = {.lex_state = 0, .external_lex_state = 2},
  [537] = {.lex_state = 0, .external_lex_state = 2},
  [538] = {.lex_state = 0, .external_lex_state = 2},
  [539] = {.lex_state = 0, .external_lex_state = 7},
  [540] = {.lex_state = 0, .external_lex_state = 2},
  [541] = {.lex_state = 0, .external_lex_state = 2},
  [542] = {.lex_state = 0, .external_lex_state = 2},
  [543] = {.lex_state = 0, .external_lex_state = 2},
  [544] = {.lex_state = 0, .external_lex_state = 2},
  [545] = {.lex_state = 0, .external_lex_state = 2},
  [546] = {.lex_state = 0, .external_lex_state = 2},
  [547] = {.lex_state = 0, .external_lex_state = 2},
  [548] = {.lex_state = 0, .external_lex_state = 2},
  [549] = {.lex_state = 0, .external_lex_state = 2},
  [550] = {.lex_state = 0, .external_lex_state = 2},
  [551] = {.lex_state = 0, .external_lex_state = 2},
  [552] = {.lex_state = 0, .external_lex_state = 2},
  [553] = {.lex_state = 0, .external_lex_state = 6},
  [554] = {.lex_state = 0, .external_lex_state = 2},
  [555] = {.lex_state = 0, .external_lex_state = 2},
  [556] = {.lex_state = 0, .external_lex_state = 2},
  [557] = {.lex_state = 0, .external_lex_state = 2},
  [558] = {.lex_state = 0, .external_lex_state = 2},
  [559] = {.lex_state = 0, .external_lex_state = 6},
  [560] = {.lex_state = 0, .external_lex_state = 2},
  [561] = {.lex_state = 0, .external_lex_state = 2},
  [562] = {.lex_state = 0, .external_lex_state = 2},
  [563] = {.lex_state = 0, .external_lex_state = 4},
  [564] = {.lex_state = 107, .external_lex_state = 2},
  [565] = {.lex_state = 0, .external_lex_state = 2},
  [566] = {.lex_state = 0, .external_lex_state = 2},
  [567] = {.lex_state = 0, .external_lex_state = 2},
  [568] = {.lex_state = 0, .external_lex_state = 2},
  [569] = {.lex_state = 0, .external_lex_state = 2},
  [570] = {.lex_state = 0, .external_lex_state = 2},
  [571] = {.lex_state = 0, .external_lex_state = 2},
  [572] = {.lex_state = 0, .external_lex_state = 2},
  [573] = {.lex_state = 0, .external_lex_state = 2},
  [574] = {.lex_state = 0, .external_lex_state = 2},
  [575] = {.lex_state = 0, .external_lex_state = 2},
  [576] = {.lex_state = 0, .external_lex_state = 4},
  [577] = {.lex_state = 0, .external_lex_state = 4},
  [578] = {.lex_state = 0, .external_lex_state = 2},
  [579] = {.lex_state = 0, .external_lex_state = 2},
  [580] = {.lex_state = 0, .external_lex_state = 2},
  [581] = {.lex_state = 0, .external_lex_state = 2},
  [582] = {.lex_state = 0, .external_lex_state = 2},
  [583] = {(TSStateId)(-1)},
  [584] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [sym_continue_statement] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_thread] = ACTIONS(1),
    [anon_sym_buffer] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_userdata] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_table] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_LBRACE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym__block_comment_start] = ACTIONS(5),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__block_comment_end] = ACTIONS(1),
    [sym__block_string_start] = ACTIONS(1),
    [sym__block_string_content] = ACTIONS(1),
    [sym__block_string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_chunk] = STATE(573),
    [sym_statement] = STATE(255),
    [sym_return_statement] = STATE(538),
    [sym_empty_statement] = STATE(282),
    [sym_assignment_statement] = STATE(282),
    [sym__variable_assignment_varlist] = STATE(333),
    [sym_do_statement] = STATE(282),
    [sym_while_statement] = STATE(282),
    [sym_repeat_statement] = STATE(282),
    [sym_if_statement] = STATE(282),
    [sym_for_statement] = STATE(282),
    [sym_declaration] = STATE(261),
    [sym_function_declaration] = STATE(271),
    [sym__local_function_declaration] = STATE(276),
    [sym_variable_declaration] = STATE(264),
    [sym__prefix_expression] = STATE(312),
    [sym_variable] = STATE(270),
    [sym_bracket_index_expression] = STATE(2),
    [sym_dot_index_expression] = STATE(2),
    [sym_function_call] = STATE(232),
    [sym_method_index_expression] = STATE(313),
    [sym_parenthesized_expression] = STATE(328),
    [sym_comment] = STATE(1),
    [sym_update_statement] = STATE(282),
    [sym_type_definition] = STATE(282),
    [aux_sym_chunk_repeat1] = STATE(122),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [sym_hash_bang_line] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [sym_break_statement] = ACTIONS(17),
    [anon_sym_do] = ACTIONS(19),
    [anon_sym_while] = ACTIONS(21),
    [anon_sym_repeat] = ACTIONS(23),
    [anon_sym_if] = ACTIONS(25),
    [anon_sym_for] = ACTIONS(27),
    [anon_sym_function] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [sym_continue_statement] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(35),
    [anon_sym_type] = ACTIONS(37),
    [sym__block_comment_start] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(2), 1,
      sym_comment,
    ACTIONS(39), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(41), 33,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [73] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(3), 1,
      sym_comment,
    ACTIONS(43), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(45), 33,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [146] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(4), 1,
      sym_comment,
    ACTIONS(47), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(49), 33,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [219] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(5), 1,
      sym_comment,
    ACTIONS(51), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(53), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [283] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(59), 1,
      anon_sym_DOT,
    STATE(6), 1,
      sym_comment,
    STATE(11), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(55), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(57), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [351] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(7), 1,
      sym_comment,
    ACTIONS(61), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(63), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [415] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(8), 1,
      sym_comment,
    ACTIONS(65), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(67), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [479] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(9), 1,
      sym_comment,
    ACTIONS(69), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(71), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [543] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(10), 1,
      sym_comment,
    ACTIONS(77), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(79), 7,
      sym__block_string_start,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(73), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(75), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [611] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(59), 1,
      anon_sym_DOT,
    STATE(11), 1,
      sym_comment,
    STATE(13), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(81), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(83), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [679] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(12), 1,
      sym_comment,
    ACTIONS(85), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(87), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [743] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(93), 1,
      anon_sym_DOT,
    STATE(13), 2,
      sym_comment,
      aux_sym_field_type_repeat1,
    ACTIONS(89), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(91), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [809] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(14), 1,
      sym_comment,
    ACTIONS(96), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(98), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [873] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(15), 1,
      sym_comment,
    ACTIONS(100), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(102), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [937] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(16), 1,
      sym_comment,
    ACTIONS(104), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(106), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1001] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(17), 1,
      sym_comment,
    ACTIONS(108), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(110), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1065] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(18), 1,
      sym_comment,
    ACTIONS(112), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(114), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1129] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(19), 1,
      sym_comment,
    ACTIONS(112), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(114), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1193] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(20), 1,
      sym_comment,
    ACTIONS(116), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(118), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1257] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(21), 1,
      sym_comment,
    ACTIONS(120), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(122), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1321] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(22), 1,
      sym_comment,
    ACTIONS(124), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(126), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1385] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(23), 1,
      sym_comment,
    ACTIONS(128), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(130), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1449] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(24), 1,
      sym_comment,
    ACTIONS(132), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    ACTIONS(134), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1513] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(140), 1,
      anon_sym_DASH_GT,
    STATE(25), 1,
      sym_comment,
    ACTIONS(136), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(138), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1578] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(146), 1,
      anon_sym_DASH_GT,
    STATE(26), 1,
      sym_comment,
    ACTIONS(142), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(144), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1643] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(27), 1,
      sym_comment,
    ACTIONS(89), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(91), 28,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1706] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(152), 1,
      anon_sym_DASH_GT,
    STATE(28), 1,
      sym_comment,
    ACTIONS(148), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(150), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1771] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(29), 1,
      sym_comment,
    ACTIONS(132), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(134), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1833] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(30), 1,
      sym_comment,
    ACTIONS(154), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(156), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1895] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(31), 1,
      sym_comment,
    ACTIONS(158), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(160), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1957] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(32), 1,
      sym_comment,
    ACTIONS(55), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(57), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2019] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(33), 1,
      sym_comment,
    ACTIONS(162), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(164), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2089] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(34), 1,
      sym_comment,
    ACTIONS(174), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(176), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2151] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(35), 1,
      sym_comment,
    ACTIONS(178), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(180), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2213] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(36), 1,
      sym_comment,
    ACTIONS(182), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(184), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2275] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(37), 1,
      sym_comment,
    ACTIONS(186), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(188), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2337] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(170), 1,
      anon_sym_AMP,
    STATE(38), 1,
      sym_comment,
    ACTIONS(190), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(192), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2401] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(39), 1,
      sym_comment,
    ACTIONS(194), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(196), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2463] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(40), 1,
      sym_comment,
    ACTIONS(198), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(200), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2533] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(41), 1,
      sym_comment,
    ACTIONS(202), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(204), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2595] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(42), 1,
      sym_comment,
    ACTIONS(206), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(208), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2657] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(43), 1,
      sym_comment,
    ACTIONS(51), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(53), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2719] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(44), 1,
      sym_comment,
    ACTIONS(210), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(212), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2781] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(45), 1,
      sym_comment,
    ACTIONS(214), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(216), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2843] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(46), 1,
      sym_comment,
    ACTIONS(218), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(220), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2913] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(47), 1,
      sym_comment,
    ACTIONS(222), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(224), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2975] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(48), 1,
      sym_comment,
    ACTIONS(226), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(228), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3037] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(49), 1,
      sym_comment,
    ACTIONS(230), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(232), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3107] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(50), 1,
      sym_comment,
    ACTIONS(234), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(236), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3169] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(51), 1,
      sym_comment,
    ACTIONS(238), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(240), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3239] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(52), 1,
      sym_comment,
    ACTIONS(242), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(244), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3309] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(53), 1,
      sym_comment,
    ACTIONS(246), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(248), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3379] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(54), 1,
      sym_comment,
    ACTIONS(250), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(252), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3449] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(55), 1,
      sym_comment,
    ACTIONS(112), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(114), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3511] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(56), 1,
      sym_comment,
    ACTIONS(112), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(114), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3573] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(57), 1,
      sym_comment,
    ACTIONS(116), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(118), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3635] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(58), 1,
      sym_comment,
    ACTIONS(124), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(126), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3697] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(59), 1,
      sym_comment,
    ACTIONS(120), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(122), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3759] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(60), 1,
      sym_comment,
    ACTIONS(128), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
    ACTIONS(130), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3821] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(61), 1,
      sym_comment,
    ACTIONS(254), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(256), 27,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3891] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(62), 1,
      sym_comment,
    ACTIONS(258), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(260), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3959] = 39,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(264), 1,
      anon_sym_end,
    ACTIONS(266), 1,
      anon_sym_elseif,
    ACTIONS(268), 1,
      anon_sym_else,
    STATE(63), 1,
      sym_comment,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(396), 1,
      sym__block,
    STATE(398), 1,
      aux_sym_if_statement_repeat1,
    STATE(430), 1,
      sym_return_statement,
    STATE(478), 1,
      sym_elseif_statement,
    STATE(551), 1,
      sym_else_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4087] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_elseif,
    ACTIONS(276), 1,
      anon_sym_else,
    STATE(64), 1,
      sym_comment,
    STATE(68), 1,
      aux_sym_if_expression_repeat1,
    STATE(84), 1,
      sym_elseif_clause,
    STATE(91), 1,
      sym_else_clause,
    ACTIONS(270), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(272), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4156] = 38,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(278), 1,
      anon_sym_end,
    STATE(65), 1,
      sym_comment,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(565), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4281] = 38,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(280), 1,
      anon_sym_end,
    STATE(66), 1,
      sym_comment,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(535), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4406] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_elseif,
    ACTIONS(276), 1,
      anon_sym_else,
    ACTIONS(288), 1,
      anon_sym_or,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(64), 1,
      aux_sym_if_expression_repeat1,
    STATE(67), 1,
      sym_comment,
    STATE(84), 1,
      sym_elseif_clause,
    STATE(85), 1,
      sym_else_clause,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(282), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(284), 16,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4497] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(312), 1,
      anon_sym_elseif,
    STATE(84), 1,
      sym_elseif_clause,
    STATE(68), 2,
      sym_comment,
      aux_sym_if_expression_repeat1,
    ACTIONS(308), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(310), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4559] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    STATE(69), 1,
      sym_comment,
    STATE(73), 1,
      aux_sym_chunk_repeat1,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(443), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(315), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4672] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(317), 1,
      anon_sym_SEMI,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(70), 1,
      sym_comment,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(234), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(401), 1,
      sym__expression_list,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    ACTIONS(319), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [4779] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(71), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(467), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(347), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4894] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(72), 1,
      sym_comment,
    ACTIONS(349), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(351), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4951] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(353), 1,
      ts_builtin_sym_end,
    ACTIONS(355), 1,
      sym_identifier,
    ACTIONS(360), 1,
      anon_sym_SEMI,
    ACTIONS(366), 1,
      anon_sym_do,
    ACTIONS(369), 1,
      anon_sym_while,
    ACTIONS(372), 1,
      anon_sym_repeat,
    ACTIONS(375), 1,
      anon_sym_if,
    ACTIONS(378), 1,
      anon_sym_for,
    ACTIONS(381), 1,
      anon_sym_function,
    ACTIONS(384), 1,
      anon_sym_local,
    ACTIONS(387), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_export,
    ACTIONS(393), 1,
      anon_sym_type,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    ACTIONS(363), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(73), 2,
      sym_comment,
      aux_sym_chunk_repeat1,
    ACTIONS(358), 5,
      anon_sym_return,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [5060] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(74), 1,
      sym_comment,
    ACTIONS(396), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(398), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5116] = 23,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(400), 1,
      sym_identifier,
    ACTIONS(402), 1,
      anon_sym_COMMA,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_LBRACK,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(420), 1,
      anon_sym_RBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(75), 1,
      sym_comment,
    STATE(387), 1,
      sym_type,
    STATE(579), 1,
      sym_object_field_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [5208] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(76), 1,
      sym_comment,
    ACTIONS(112), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(114), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5264] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(77), 1,
      sym_comment,
    ACTIONS(426), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(428), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5320] = 35,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(430), 1,
      anon_sym_end,
    ACTIONS(432), 1,
      anon_sym_COLON,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(78), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(578), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [5436] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(79), 1,
      sym_comment,
    ACTIONS(124), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(126), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5492] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(80), 1,
      sym_comment,
    ACTIONS(104), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(106), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5548] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(304), 1,
      anon_sym_CARET,
    STATE(81), 1,
      sym_comment,
    ACTIONS(434), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(436), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5606] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(82), 1,
      sym_comment,
    ACTIONS(438), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(440), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5662] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(83), 1,
      sym_comment,
    ACTIONS(120), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(122), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5718] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(84), 1,
      sym_comment,
    ACTIONS(442), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(444), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5774] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(85), 1,
      sym_comment,
    ACTIONS(270), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(272), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5830] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(86), 1,
      sym_comment,
    ACTIONS(446), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(448), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5886] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(87), 1,
      sym_comment,
    ACTIONS(450), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(452), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5942] = 23,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_LBRACK,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(454), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_COMMA,
    ACTIONS(458), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(88), 1,
      sym_comment,
    STATE(350), 1,
      sym_type,
    STATE(567), 1,
      sym_object_field_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [6034] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(89), 1,
      sym_comment,
    ACTIONS(116), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(118), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6090] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(288), 1,
      anon_sym_or,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(90), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(460), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(462), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6168] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(91), 1,
      sym_comment,
    ACTIONS(464), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(466), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6224] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(92), 1,
      sym_comment,
    ACTIONS(468), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(470), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6280] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(93), 1,
      sym_comment,
    ACTIONS(472), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(474), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6336] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(94), 1,
      sym_comment,
    ACTIONS(476), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(478), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6392] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(95), 1,
      sym_comment,
    ACTIONS(128), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(130), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6448] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(96), 1,
      sym_comment,
    ACTIONS(480), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(482), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6504] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(288), 1,
      anon_sym_or,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(97), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(484), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(486), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6582] = 35,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(488), 1,
      anon_sym_end,
    ACTIONS(490), 1,
      anon_sym_COLON,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(98), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(540), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [6698] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(99), 1,
      sym_comment,
    ACTIONS(132), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(134), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6754] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(100), 1,
      sym_comment,
    ACTIONS(108), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(110), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6810] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(101), 1,
      sym_comment,
    ACTIONS(51), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(53), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6866] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(102), 1,
      sym_comment,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(492), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(494), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6936] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(103), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(492), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(494), 19,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7012] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(104), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(492), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(494), 20,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7086] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(105), 1,
      sym_comment,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(492), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DOT_DOT,
    ACTIONS(494), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7150] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(106), 1,
      sym_comment,
    ACTIONS(492), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(494), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7210] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(107), 1,
      sym_comment,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(492), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(494), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7280] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(304), 1,
      anon_sym_CARET,
    STATE(108), 1,
      sym_comment,
    ACTIONS(492), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(494), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7338] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(109), 1,
      sym_comment,
    ACTIONS(496), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(498), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7394] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(110), 1,
      sym_comment,
    ACTIONS(73), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(75), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7450] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(111), 1,
      sym_comment,
    ACTIONS(112), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
    ACTIONS(114), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [7506] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(500), 1,
      anon_sym_end,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(112), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(546), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7619] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(502), 1,
      anon_sym_until,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(113), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(575), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7732] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(504), 1,
      anon_sym_end,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(114), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(557), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7845] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(506), 1,
      anon_sym_end,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(115), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(523), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7958] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(262), 1,
      anon_sym_return,
    ACTIONS(508), 1,
      anon_sym_end,
    STATE(69), 1,
      aux_sym_chunk_repeat1,
    STATE(116), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(430), 1,
      sym_return_statement,
    STATE(508), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [8071] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(512), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_RBRACE,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(117), 1,
      sym_comment,
    STATE(265), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(419), 1,
      sym_field,
    STATE(571), 1,
      sym__field_list,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8178] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(512), 1,
      anon_sym_LBRACK,
    ACTIONS(516), 1,
      anon_sym_RBRACE,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(118), 1,
      sym_comment,
    STATE(265), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(419), 1,
      sym_field,
    STATE(507), 1,
      sym__field_list,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8285] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(512), 1,
      anon_sym_LBRACK,
    ACTIONS(518), 1,
      anon_sym_RBRACE,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(119), 1,
      sym_comment,
    STATE(265), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(460), 1,
      sym_field,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8389] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(520), 1,
      sym_identifier,
    ACTIONS(522), 1,
      anon_sym_COMMA,
    ACTIONS(524), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(120), 1,
      sym_comment,
    STATE(348), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8475] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(512), 1,
      anon_sym_LBRACK,
    ACTIONS(526), 1,
      anon_sym_RBRACE,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_comment,
    STATE(265), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(460), 1,
      sym_field,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8579] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(528), 1,
      ts_builtin_sym_end,
    STATE(73), 1,
      aux_sym_chunk_repeat1,
    STATE(122), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(511), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [8689] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(530), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    ACTIONS(534), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(123), 1,
      sym_comment,
    STATE(386), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8775] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(317), 1,
      anon_sym_SEMI,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    ACTIONS(536), 1,
      ts_builtin_sym_end,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(124), 1,
      sym_comment,
    STATE(234), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(401), 1,
      sym__expression_list,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8879] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(528), 1,
      ts_builtin_sym_end,
    STATE(125), 1,
      sym_comment,
    STATE(126), 1,
      aux_sym_chunk_repeat1,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(511), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [8989] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(538), 1,
      ts_builtin_sym_end,
    STATE(73), 1,
      aux_sym_chunk_repeat1,
    STATE(126), 1,
      sym_comment,
    STATE(232), 1,
      sym_function_call,
    STATE(255), 1,
      sym_statement,
    STATE(261), 1,
      sym_declaration,
    STATE(264), 1,
      sym_variable_declaration,
    STATE(270), 1,
      sym_variable,
    STATE(271), 1,
      sym_function_declaration,
    STATE(276), 1,
      sym__local_function_declaration,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(328), 1,
      sym_parenthesized_expression,
    STATE(333), 1,
      sym__variable_assignment_varlist,
    STATE(525), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(282), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [9099] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_typeof,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(127), 1,
      sym_comment,
    STATE(239), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9182] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(128), 1,
      sym_comment,
    STATE(351), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9265] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(548), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(129), 1,
      sym_comment,
    STATE(349), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9348] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(550), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(130), 1,
      sym_comment,
    STATE(389), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9431] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(552), 1,
      anon_sym_typeof,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(131), 1,
      sym_comment,
    STATE(238), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9514] = 29,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(512), 1,
      anon_sym_LBRACK,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(132), 1,
      sym_comment,
    STATE(265), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(460), 1,
      sym_field,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [9615] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(554), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(133), 1,
      sym_comment,
    STATE(389), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9698] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(558), 1,
      anon_sym_GT,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(134), 1,
      sym_comment,
    STATE(343), 1,
      sym_type,
    STATE(354), 1,
      sym_string,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9781] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(578), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(135), 1,
      sym_comment,
    STATE(364), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9864] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(136), 1,
      sym_comment,
    STATE(352), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9947] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(288), 1,
      anon_sym_or,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(586), 1,
      anon_sym_COMMA,
    STATE(137), 1,
      sym_comment,
    STATE(247), 1,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(582), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(584), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [10026] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    ACTIONS(588), 1,
      anon_sym_GT,
    STATE(138), 1,
      sym_comment,
    STATE(341), 1,
      sym_type,
    STATE(354), 1,
      sym_string,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10109] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(590), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(139), 1,
      sym_comment,
    STATE(389), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10192] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(592), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(140), 1,
      sym_comment,
    STATE(389), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10275] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(141), 1,
      sym_comment,
    STATE(391), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10358] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(142), 1,
      sym_comment,
    STATE(345), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10441] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(143), 1,
      sym_comment,
    STATE(275), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10539] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(144), 1,
      sym_comment,
    STATE(423), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10619] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(40), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(145), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10699] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(146), 1,
      sym_comment,
    STATE(344), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10779] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(147), 1,
      sym_comment,
    STATE(389), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10859] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(148), 1,
      sym_comment,
    STATE(390), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10939] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(33), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(149), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11019] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(150), 1,
      sym_comment,
    STATE(403), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11099] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(66), 1,
      sym_type,
    STATE(151), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11179] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(152), 1,
      sym_comment,
    STATE(394), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11259] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(153), 1,
      sym_comment,
    STATE(233), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11339] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(61), 1,
      sym_type,
    STATE(154), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11419] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(62), 1,
      sym_type,
    STATE(155), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11499] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(156), 1,
      sym_comment,
    STATE(347), 1,
      sym_type,
    STATE(354), 1,
      sym_string,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11579] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(288), 1,
      anon_sym_or,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(157), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(598), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(600), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [11653] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(158), 1,
      sym_comment,
    STATE(346), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11733] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(159), 1,
      sym_comment,
    STATE(234), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(543), 1,
      sym__expression_list,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11831] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(46), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(160), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11911] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(161), 1,
      sym_comment,
    STATE(231), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11991] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(162), 1,
      sym_comment,
    STATE(283), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12089] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(163), 1,
      sym_comment,
    STATE(269), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12187] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(164), 1,
      sym_comment,
    STATE(272), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12285] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(49), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(165), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12365] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(166), 1,
      sym_comment,
    STATE(417), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12445] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(167), 1,
      sym_comment,
    STATE(392), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12525] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(168), 1,
      sym_comment,
    STATE(274), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [12623] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(51), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(169), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12703] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(170), 1,
      sym_comment,
    STATE(404), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12783] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(171), 1,
      sym_comment,
    STATE(407), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12863] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(38), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(172), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12943] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(39), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(173), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13023] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(52), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(174), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13103] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(175), 1,
      sym_comment,
    STATE(277), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [13201] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(53), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(176), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13281] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(54), 1,
      sym_type,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(177), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13361] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(178), 1,
      sym_comment,
    STATE(279), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [13459] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(179), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(356), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13539] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(180), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(361), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13619] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(181), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(362), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13699] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(182), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(363), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13779] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(183), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(366), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13859] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(184), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(369), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13939] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(185), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(372), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14019] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(186), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(374), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14099] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(187), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(375), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14179] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(188), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(376), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14259] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(556), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_SQUOTE,
    ACTIONS(568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(570), 1,
      anon_sym_LPAREN,
    ACTIONS(572), 1,
      anon_sym_LBRACE,
    ACTIONS(574), 1,
      anon_sym_BQUOTE,
    ACTIONS(576), 1,
      sym__block_string_start,
    STATE(189), 1,
      sym_comment,
    STATE(354), 1,
      sym_string,
    STATE(377), 1,
      sym_type,
    STATE(378), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__block_string,
    STATE(380), 1,
      sym__interpolated_string,
    ACTIONS(562), 2,
      sym_false,
      sym_true,
    ACTIONS(560), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(355), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14339] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(190), 1,
      sym_comment,
    STATE(280), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14437] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(191), 1,
      sym_comment,
    STATE(412), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14517] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(192), 1,
      sym_comment,
    STATE(281), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14615] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    ACTIONS(602), 1,
      anon_sym_RPAREN,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(193), 1,
      sym_comment,
    STATE(253), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14713] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(65), 1,
      sym_type,
    STATE(194), 1,
      sym_comment,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14793] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(408), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_SQUOTE,
    ACTIONS(412), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(418), 1,
      anon_sym_LBRACE,
    ACTIONS(422), 1,
      anon_sym_BQUOTE,
    ACTIONS(424), 1,
      sym__block_string_start,
    ACTIONS(540), 1,
      sym_identifier,
    STATE(31), 1,
      sym_string,
    STATE(55), 1,
      sym__quote_string,
    STATE(56), 1,
      sym__block_string,
    STATE(57), 1,
      sym__interpolated_string,
    STATE(195), 1,
      sym_comment,
    STATE(388), 1,
      sym_type,
    ACTIONS(406), 2,
      sym_false,
      sym_true,
    ACTIONS(404), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(32), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14873] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(137), 1,
      sym_expression,
    STATE(196), 1,
      sym_comment,
    STATE(273), 1,
      sym__variable_assignment_explist,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14971] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(197), 1,
      sym_comment,
    STATE(256), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15066] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(198), 1,
      sym_comment,
    STATE(288), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15161] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(199), 1,
      sym_comment,
    STATE(297), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15256] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(288), 1,
      anon_sym_or,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(200), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(604), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(606), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [15329] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(201), 1,
      sym_comment,
    STATE(236), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15424] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(202), 1,
      sym_comment,
    STATE(220), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15519] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(102), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(203), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15614] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(157), 1,
      sym_expression,
    STATE(204), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15709] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(205), 1,
      sym_comment,
    STATE(306), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15804] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(206), 1,
      sym_comment,
    STATE(300), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15899] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(103), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(207), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15994] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(208), 1,
      sym_comment,
    STATE(304), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16089] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(97), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(209), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16184] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(210), 1,
      sym_comment,
    STATE(302), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16279] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(104), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(211), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16374] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(105), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(212), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16469] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(106), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(213), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16564] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(107), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(214), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16659] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(108), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(215), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16754] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(216), 1,
      sym_comment,
    STATE(307), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16849] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(217), 1,
      sym_comment,
    STATE(308), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16944] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(218), 1,
      sym_comment,
    STATE(309), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17039] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(90), 1,
      sym_expression,
    STATE(111), 1,
      sym__quote_string,
    STATE(219), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17134] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(288), 1,
      anon_sym_or,
    ACTIONS(290), 1,
      anon_sym_and,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    STATE(220), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(608), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(610), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17207] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(200), 1,
      sym_expression,
    STATE(221), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17302] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(222), 1,
      sym_comment,
    STATE(301), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17397] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(81), 1,
      sym_expression,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(223), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17492] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(224), 1,
      sym_comment,
    STATE(298), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17587] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(67), 1,
      sym_expression,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(225), 1,
      sym_comment,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17682] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(226), 1,
      sym_comment,
    STATE(305), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17777] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(227), 1,
      sym_comment,
    STATE(303), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17872] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(228), 1,
      sym_comment,
    STATE(299), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17967] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_if,
    ACTIONS(323), 1,
      anon_sym_function,
    ACTIONS(325), 1,
      anon_sym_nil,
    ACTIONS(329), 1,
      sym_number,
    ACTIONS(331), 1,
      anon_sym_DQUOTE,
    ACTIONS(333), 1,
      anon_sym_SQUOTE,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(337), 1,
      anon_sym_LBRACE,
    ACTIONS(341), 1,
      anon_sym_POUND,
    ACTIONS(343), 1,
      anon_sym_BQUOTE,
    ACTIONS(345), 1,
      sym__block_string_start,
    STATE(76), 1,
      sym__block_string,
    STATE(89), 1,
      sym__interpolated_string,
    STATE(111), 1,
      sym__quote_string,
    STATE(229), 1,
      sym_comment,
    STATE(294), 1,
      sym_expression,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    ACTIONS(327), 2,
      sym_false,
      sym_true,
    ACTIONS(339), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(10), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(110), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [18062] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(612), 1,
      anon_sym_EQ,
    STATE(230), 1,
      sym_comment,
    ACTIONS(41), 6,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(39), 23,
      sym__block_string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
  [18108] = 13,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    ACTIONS(620), 1,
      anon_sym_LT,
    STATE(231), 1,
      sym_comment,
    STATE(245), 1,
      sym__attrib,
    STATE(246), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(614), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(616), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18167] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(232), 1,
      sym_comment,
    ACTIONS(622), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(79), 9,
      sym__block_string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(624), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18211] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(620), 1,
      anon_sym_LT,
    STATE(233), 1,
      sym_comment,
    STATE(248), 1,
      sym__attrib,
    ACTIONS(626), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(628), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18265] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(632), 1,
      anon_sym_COMMA,
    ACTIONS(634), 1,
      anon_sym_else,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    STATE(234), 1,
      sym_comment,
    STATE(327), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(630), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [18331] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    ACTIONS(644), 1,
      anon_sym_COLON,
    ACTIONS(646), 1,
      anon_sym_LT,
    STATE(235), 1,
      sym_comment,
    STATE(241), 1,
      sym__attrib,
    STATE(243), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(640), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(642), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18381] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(650), 1,
      anon_sym_else,
    STATE(236), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(648), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [18443] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(646), 1,
      anon_sym_LT,
    ACTIONS(656), 1,
      anon_sym_COLON,
    STATE(237), 1,
      sym_comment,
    STATE(251), 1,
      sym__attrib,
    ACTIONS(652), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(654), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18488] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(238), 1,
      sym_comment,
    ACTIONS(658), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(660), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18534] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(239), 1,
      sym_comment,
    ACTIONS(662), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(664), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18580] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    STATE(240), 1,
      sym_comment,
    STATE(242), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(666), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(668), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18621] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    STATE(241), 1,
      sym_comment,
    STATE(244), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(670), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(672), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18662] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(678), 1,
      anon_sym_COMMA,
    STATE(242), 2,
      sym_comment,
      aux_sym__att_name_list_repeat1,
    ACTIONS(674), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(676), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18701] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    STATE(242), 1,
      aux_sym__att_name_list_repeat1,
    STATE(243), 1,
      sym_comment,
    ACTIONS(681), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(683), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18742] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    STATE(242), 1,
      aux_sym__att_name_list_repeat1,
    STATE(244), 1,
      sym_comment,
    ACTIONS(685), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(687), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18783] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    STATE(240), 1,
      aux_sym__att_name_list_repeat1,
    STATE(245), 1,
      sym_comment,
    ACTIONS(689), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(691), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18824] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_COMMA,
    STATE(242), 1,
      aux_sym__att_name_list_repeat1,
    STATE(246), 1,
      sym_comment,
    ACTIONS(693), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(695), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18865] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(586), 1,
      anon_sym_COMMA,
    STATE(247), 1,
      sym_comment,
    STATE(249), 1,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(697), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(699), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18905] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(248), 1,
      sym_comment,
    ACTIONS(701), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(703), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18941] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(709), 1,
      anon_sym_COMMA,
    STATE(249), 2,
      sym_comment,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(705), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(707), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18979] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(250), 1,
      sym_comment,
    ACTIONS(712), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(714), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19015] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(251), 1,
      sym_comment,
    ACTIONS(716), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(718), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19051] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(724), 1,
      anon_sym_EQ,
    STATE(252), 1,
      sym_comment,
    ACTIONS(720), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(722), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19088] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(632), 1,
      anon_sym_COMMA,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(726), 1,
      anon_sym_RPAREN,
    STATE(253), 1,
      sym_comment,
    STATE(499), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19146] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(254), 1,
      sym_comment,
    ACTIONS(728), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(730), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19180] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(255), 1,
      sym_comment,
    ACTIONS(732), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(734), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19214] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    STATE(256), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(736), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19268] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(257), 1,
      sym_comment,
    ACTIONS(738), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(740), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19302] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(258), 1,
      sym_comment,
    ACTIONS(742), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(744), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19336] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(259), 1,
      sym_comment,
    ACTIONS(746), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(748), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19370] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(260), 1,
      sym_comment,
    ACTIONS(750), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(752), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19404] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(261), 1,
      sym_comment,
    ACTIONS(754), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(756), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19438] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(262), 1,
      sym_comment,
    ACTIONS(758), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(760), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19472] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(263), 1,
      sym_comment,
    ACTIONS(762), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(764), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19506] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(264), 1,
      sym_comment,
    ACTIONS(766), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(768), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19540] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    STATE(265), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(770), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19594] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(266), 1,
      sym_comment,
    ACTIONS(772), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(774), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19628] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(267), 1,
      sym_comment,
    ACTIONS(776), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(778), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19662] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(268), 1,
      sym_comment,
    ACTIONS(780), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(782), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19696] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(269), 1,
      sym_comment,
    ACTIONS(784), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(786), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19730] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(77), 1,
      anon_sym_DOT,
    ACTIONS(790), 1,
      anon_sym_COMMA,
    STATE(270), 1,
      sym_comment,
    STATE(314), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(79), 8,
      sym__block_string_start,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(788), 9,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [19770] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(271), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19804] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(272), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19838] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(273), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19872] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(274), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19906] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(275), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19940] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(276), 1,
      sym_comment,
    ACTIONS(800), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(802), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19974] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(277), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20008] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(278), 1,
      sym_comment,
    ACTIONS(804), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(806), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20042] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(279), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20076] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(280), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20110] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(281), 1,
      sym_comment,
    ACTIONS(796), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(798), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20144] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(282), 1,
      sym_comment,
    ACTIONS(622), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(624), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20178] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(283), 1,
      sym_comment,
    ACTIONS(808), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(810), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20212] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(284), 1,
      sym_comment,
    ACTIONS(812), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(814), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20246] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(285), 1,
      sym_comment,
    ACTIONS(816), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(818), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20280] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(286), 1,
      sym_comment,
    ACTIONS(820), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(822), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20314] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(287), 1,
      sym_comment,
    ACTIONS(824), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(826), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20348] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    STATE(288), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(828), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20402] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(289), 1,
      sym_comment,
    ACTIONS(830), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(832), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20436] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(290), 1,
      sym_comment,
    ACTIONS(834), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(836), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20470] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(291), 1,
      sym_comment,
    ACTIONS(838), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(840), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20504] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(292), 1,
      sym_comment,
    ACTIONS(842), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(844), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20538] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(293), 1,
      sym_comment,
    ACTIONS(846), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(848), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20572] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(850), 1,
      anon_sym_COMMA,
    ACTIONS(852), 1,
      anon_sym_do,
    STATE(294), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20627] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(77), 1,
      anon_sym_DOT,
    STATE(295), 1,
      sym_comment,
    ACTIONS(79), 8,
      sym__block_string_start,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(854), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [20662] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(296), 1,
      sym_comment,
    ACTIONS(856), 8,
      anon_sym_if,
      anon_sym_function,
      anon_sym_nil,
      sym_false,
      sym_true,
      anon_sym_DASH,
      anon_sym_not,
      sym_identifier,
    ACTIONS(858), 11,
      sym__block_string_start,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_BQUOTE,
  [20695] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(860), 1,
      anon_sym_RPAREN,
    STATE(297), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20747] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(862), 1,
      anon_sym_COMMA,
    STATE(298), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20799] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(864), 1,
      anon_sym_RBRACK,
    STATE(299), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20851] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(866), 1,
      anon_sym_do,
    STATE(300), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20903] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(868), 1,
      anon_sym_then,
    STATE(301), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20955] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(870), 1,
      anon_sym_RPAREN,
    STATE(302), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21007] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(872), 1,
      anon_sym_do,
    STATE(303), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21059] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(874), 1,
      anon_sym_then,
    STATE(304), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21111] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(876), 1,
      anon_sym_RBRACE,
    STATE(305), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21163] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(878), 1,
      anon_sym_then,
    STATE(306), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21215] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(880), 1,
      anon_sym_RPAREN,
    STATE(307), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21267] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(882), 1,
      anon_sym_RBRACK,
    STATE(308), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21319] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_PLUS,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(300), 1,
      anon_sym_SLASH,
    ACTIONS(302), 1,
      anon_sym_DOT_DOT,
    ACTIONS(304), 1,
      anon_sym_CARET,
    ACTIONS(306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(636), 1,
      anon_sym_or,
    ACTIONS(638), 1,
      anon_sym_and,
    ACTIONS(884), 1,
      anon_sym_then,
    STATE(309), 1,
      sym_comment,
    ACTIONS(286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(292), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [21371] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(310), 1,
      sym_comment,
    ACTIONS(888), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(886), 14,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [21402] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(311), 1,
      sym_comment,
    ACTIONS(892), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(890), 14,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [21433] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(894), 1,
      anon_sym_DOT,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(898), 1,
      anon_sym_DQUOTE,
    ACTIONS(900), 1,
      anon_sym_SQUOTE,
    ACTIONS(902), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_LBRACK,
    ACTIONS(906), 1,
      anon_sym_LBRACE,
    ACTIONS(908), 1,
      anon_sym_BQUOTE,
    ACTIONS(910), 1,
      sym__block_string_start,
    STATE(8), 1,
      sym_arguments,
    STATE(18), 1,
      sym__block_string,
    STATE(19), 1,
      sym__quote_string,
    STATE(20), 1,
      sym__interpolated_string,
    STATE(312), 1,
      sym_comment,
    STATE(7), 2,
      sym_string,
      sym_table_constructor,
  [21486] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(898), 1,
      anon_sym_DQUOTE,
    ACTIONS(900), 1,
      anon_sym_SQUOTE,
    ACTIONS(902), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACE,
    ACTIONS(908), 1,
      anon_sym_BQUOTE,
    ACTIONS(910), 1,
      sym__block_string_start,
    STATE(8), 1,
      sym_arguments,
    STATE(18), 1,
      sym__block_string,
    STATE(19), 1,
      sym__quote_string,
    STATE(20), 1,
      sym__interpolated_string,
    STATE(313), 1,
      sym_comment,
    STATE(7), 2,
      sym_string,
      sym_table_constructor,
  [21530] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(790), 1,
      anon_sym_COMMA,
    STATE(314), 1,
      sym_comment,
    STATE(315), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(912), 9,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [21557] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(916), 1,
      anon_sym_COMMA,
    STATE(315), 2,
      sym_comment,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(914), 9,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [21582] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(925), 1,
      anon_sym_BQUOTE,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    STATE(316), 1,
      sym_comment,
    STATE(324), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21620] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(650), 1,
      anon_sym_else,
    ACTIONS(933), 1,
      anon_sym_COMMA,
    STATE(317), 2,
      sym_comment,
      aux_sym__expression_list_repeat1,
    ACTIONS(648), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [21646] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(936), 1,
      anon_sym_BQUOTE,
    STATE(318), 1,
      sym_comment,
    STATE(320), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21684] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(938), 1,
      anon_sym_BQUOTE,
    STATE(318), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(319), 1,
      sym_comment,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21722] = 11,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(940), 1,
      sym_escape_sequence,
    ACTIONS(943), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_BQUOTE,
    ACTIONS(948), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(951), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(954), 1,
      aux_sym__escape_sequence_token1,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(320), 2,
      sym_comment,
      aux_sym__interpolated_string_repeat1,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21758] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(957), 1,
      anon_sym_BQUOTE,
    STATE(321), 1,
      sym_comment,
    STATE(322), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21796] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(959), 1,
      anon_sym_BQUOTE,
    STATE(320), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(322), 1,
      sym_comment,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21834] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(961), 1,
      anon_sym_BQUOTE,
    STATE(320), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(323), 1,
      sym_comment,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21872] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(963), 1,
      anon_sym_BQUOTE,
    STATE(320), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(324), 1,
      sym_comment,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21910] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(921), 1,
      anon_sym_LBRACE,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(929), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(931), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(965), 1,
      anon_sym_BQUOTE,
    STATE(323), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(325), 1,
      sym_comment,
    STATE(408), 1,
      sym__interpolation_string_content,
    STATE(409), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21948] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(967), 1,
      anon_sym_DOT,
    STATE(326), 1,
      sym_comment,
    STATE(334), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(55), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21973] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(632), 1,
      anon_sym_COMMA,
    ACTIONS(971), 1,
      anon_sym_else,
    STATE(317), 1,
      aux_sym__expression_list_repeat1,
    STATE(327), 1,
      sym_comment,
    ACTIONS(969), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [22000] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(328), 1,
      sym_comment,
    ACTIONS(79), 9,
      sym__block_string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
  [22021] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(973), 1,
      anon_sym_DOT,
    STATE(329), 2,
      sym_comment,
      aux_sym_field_type_repeat1,
    ACTIONS(89), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22044] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(976), 1,
      anon_sym_DOT,
    ACTIONS(978), 1,
      anon_sym_COLON,
    STATE(11), 1,
      aux_sym_field_type_repeat1,
    STATE(330), 1,
      sym_comment,
    ACTIONS(55), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22071] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(976), 1,
      anon_sym_DOT,
    ACTIONS(980), 1,
      anon_sym_COLON,
    STATE(11), 1,
      aux_sym_field_type_repeat1,
    STATE(331), 1,
      sym_comment,
    ACTIONS(55), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22098] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(976), 1,
      anon_sym_DOT,
    ACTIONS(982), 1,
      anon_sym_COLON,
    STATE(11), 1,
      aux_sym_field_type_repeat1,
    STATE(332), 1,
      sym_comment,
    ACTIONS(55), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22125] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(984), 1,
      anon_sym_EQ,
    ACTIONS(986), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(988), 1,
      anon_sym_DASH_EQ,
    ACTIONS(990), 1,
      anon_sym_STAR_EQ,
    ACTIONS(992), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(994), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(996), 1,
      anon_sym_SLASH_SLASH_EQ,
    ACTIONS(998), 1,
      anon_sym_CARET_EQ,
    ACTIONS(1000), 1,
      anon_sym_DOT_DOT_EQ,
    STATE(333), 1,
      sym_comment,
  [22162] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(967), 1,
      anon_sym_DOT,
    STATE(329), 1,
      aux_sym_field_type_repeat1,
    STATE(334), 1,
      sym_comment,
    ACTIONS(81), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22187] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(1002), 1,
      sym_identifier,
    STATE(295), 1,
      sym_variable,
    STATE(312), 1,
      sym__prefix_expression,
    STATE(313), 1,
      sym_method_index_expression,
    STATE(335), 1,
      sym_comment,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(328), 2,
      sym_function_call,
      sym_parenthesized_expression,
  [22220] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(976), 1,
      anon_sym_DOT,
    ACTIONS(1004), 1,
      anon_sym_COLON,
    STATE(11), 1,
      aux_sym_field_type_repeat1,
    STATE(336), 1,
      sym_comment,
    ACTIONS(55), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22247] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(976), 1,
      anon_sym_DOT,
    ACTIONS(1006), 1,
      anon_sym_COLON,
    STATE(11), 1,
      aux_sym_field_type_repeat1,
    STATE(337), 1,
      sym_comment,
    ACTIONS(55), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22274] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(91), 1,
      anon_sym_DOT,
    STATE(338), 1,
      sym_comment,
    ACTIONS(89), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22296] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1008), 1,
      anon_sym_DASH_GT,
    STATE(339), 1,
      sym_comment,
    ACTIONS(142), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22318] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1010), 1,
      anon_sym_DASH_GT,
    STATE(340), 1,
      sym_comment,
    ACTIONS(148), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22340] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1014), 1,
      anon_sym_GT,
    ACTIONS(1016), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(341), 1,
      sym_comment,
    STATE(483), 1,
      aux_sym_generic_type_repeat1,
  [22374] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1026), 1,
      anon_sym_DASH_GT,
    STATE(342), 1,
      sym_comment,
    ACTIONS(136), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22396] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    ACTIONS(1028), 1,
      anon_sym_GT,
    ACTIONS(1030), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(343), 1,
      sym_comment,
    STATE(498), 1,
      aux_sym_generic_type_repeat1,
  [22430] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1032), 1,
      anon_sym_COMMA,
    ACTIONS(1034), 1,
      anon_sym_RPAREN,
    STATE(344), 1,
      sym_comment,
    STATE(459), 1,
      aux_sym_function_type_repeat1,
  [22461] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(578), 1,
      anon_sym_RPAREN,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    STATE(345), 1,
      sym_comment,
    STATE(493), 1,
      aux_sym_tuple_type_repeat1,
  [22492] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1038), 1,
      anon_sym_COMMA,
    ACTIONS(1040), 1,
      anon_sym_in,
    STATE(346), 1,
      sym_comment,
    STATE(471), 1,
      aux_sym__binding_list_repeat1,
  [22523] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    ACTIONS(1044), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(347), 1,
      sym_comment,
    ACTIONS(1042), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22552] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1046), 1,
      anon_sym_RPAREN,
    STATE(348), 1,
      sym_comment,
    STATE(475), 1,
      aux_sym_tuple_type_repeat1,
  [22583] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1048), 1,
      anon_sym_RPAREN,
    STATE(349), 1,
      sym_comment,
    STATE(479), 1,
      aux_sym_tuple_type_repeat1,
  [22614] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1050), 1,
      anon_sym_COMMA,
    ACTIONS(1052), 1,
      anon_sym_RBRACE,
    STATE(350), 1,
      sym_comment,
    STATE(490), 1,
      aux_sym_tuple_type_repeat1,
  [22645] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    STATE(351), 1,
      sym_comment,
    STATE(494), 1,
      aux_sym_tuple_type_repeat1,
  [22676] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
    STATE(352), 1,
      sym_comment,
    STATE(472), 1,
      aux_sym_tuple_type_repeat1,
  [22707] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(353), 1,
      sym_comment,
    ACTIONS(154), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22726] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(354), 1,
      sym_comment,
    ACTIONS(158), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22745] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(355), 1,
      sym_comment,
    ACTIONS(55), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22764] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(356), 1,
      sym_comment,
    ACTIONS(162), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [22791] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(357), 1,
      sym_comment,
    ACTIONS(174), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22810] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(358), 1,
      sym_comment,
    ACTIONS(178), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22829] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(359), 1,
      sym_comment,
    ACTIONS(182), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22848] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(360), 1,
      sym_comment,
    ACTIONS(186), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22867] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    STATE(361), 1,
      sym_comment,
    ACTIONS(190), 6,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [22888] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(362), 1,
      sym_comment,
    ACTIONS(194), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22907] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(363), 1,
      sym_comment,
    ACTIONS(198), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [22934] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1056), 1,
      anon_sym_RPAREN,
    STATE(364), 1,
      sym_comment,
    STATE(495), 1,
      aux_sym_tuple_type_repeat1,
  [22965] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(365), 1,
      sym_comment,
    ACTIONS(206), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22984] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(366), 1,
      sym_comment,
    ACTIONS(254), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [23011] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(367), 1,
      sym_comment,
    ACTIONS(210), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23030] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(368), 1,
      sym_comment,
    ACTIONS(214), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23049] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(369), 1,
      sym_comment,
    ACTIONS(218), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [23076] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(370), 1,
      sym_comment,
    ACTIONS(222), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23095] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(371), 1,
      sym_comment,
    ACTIONS(226), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23114] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(372), 1,
      sym_comment,
    ACTIONS(230), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [23141] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(373), 1,
      sym_comment,
    ACTIONS(234), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23160] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(374), 1,
      sym_comment,
    ACTIONS(238), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [23187] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(375), 1,
      sym_comment,
    ACTIONS(242), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [23214] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(376), 1,
      sym_comment,
    ACTIONS(246), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [23241] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1018), 1,
      anon_sym_LT2,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1022), 1,
      anon_sym_AMP,
    ACTIONS(1024), 1,
      anon_sym_QMARK,
    STATE(377), 1,
      sym_comment,
    ACTIONS(250), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
  [23268] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(378), 1,
      sym_comment,
    ACTIONS(112), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23287] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(379), 1,
      sym_comment,
    ACTIONS(112), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23306] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(380), 1,
      sym_comment,
    ACTIONS(116), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23325] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(381), 1,
      sym_comment,
    ACTIONS(124), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23344] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(382), 1,
      sym_comment,
    ACTIONS(120), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23363] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(383), 1,
      sym_comment,
    ACTIONS(128), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23382] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(384), 1,
      sym_comment,
    ACTIONS(132), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23401] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(385), 1,
      sym_comment,
    ACTIONS(51), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23420] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
    STATE(386), 1,
      sym_comment,
    STATE(480), 1,
      aux_sym_tuple_type_repeat1,
  [23451] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1060), 1,
      anon_sym_COMMA,
    ACTIONS(1062), 1,
      anon_sym_RBRACE,
    STATE(387), 1,
      sym_comment,
    STATE(481), 1,
      aux_sym_tuple_type_repeat1,
  [23482] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(592), 1,
      anon_sym_RBRACE,
    ACTIONS(1064), 1,
      anon_sym_COMMA,
    STATE(388), 1,
      sym_comment,
    STATE(484), 1,
      aux_sym_object_type_repeat1,
  [23513] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(389), 1,
      sym_comment,
    ACTIONS(1066), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [23540] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(550), 1,
      anon_sym_RBRACE,
    ACTIONS(1068), 1,
      anon_sym_COMMA,
    STATE(390), 1,
      sym_comment,
    STATE(462), 1,
      aux_sym_object_type_repeat1,
  [23571] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1070), 1,
      anon_sym_RPAREN,
    STATE(391), 1,
      sym_comment,
    STATE(491), 1,
      aux_sym_tuple_type_repeat1,
  [23602] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1072), 1,
      anon_sym_COMMA,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    STATE(392), 1,
      sym_comment,
    STATE(492), 1,
      aux_sym_function_type_repeat1,
  [23633] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(393), 1,
      sym_comment,
    ACTIONS(202), 7,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23652] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(394), 1,
      sym_comment,
    ACTIONS(1076), 2,
      anon_sym_COMMA,
      anon_sym_in,
  [23678] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(268), 1,
      anon_sym_else,
    ACTIONS(1078), 1,
      anon_sym_end,
    ACTIONS(1080), 1,
      anon_sym_elseif,
    STATE(395), 1,
      sym_comment,
    STATE(413), 1,
      aux_sym_if_statement_repeat1,
    STATE(478), 1,
      sym_elseif_statement,
    STATE(520), 1,
      sym_else_statement,
  [23706] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(268), 1,
      anon_sym_else,
    ACTIONS(1080), 1,
      anon_sym_elseif,
    ACTIONS(1082), 1,
      anon_sym_end,
    STATE(395), 1,
      aux_sym_if_statement_repeat1,
    STATE(396), 1,
      sym_comment,
    STATE(478), 1,
      sym_elseif_statement,
    STATE(518), 1,
      sym_else_statement,
  [23734] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(397), 1,
      sym_comment,
    ACTIONS(1084), 6,
      sym__block_string_start,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
  [23752] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(268), 1,
      anon_sym_else,
    ACTIONS(1080), 1,
      anon_sym_elseif,
    ACTIONS(1086), 1,
      anon_sym_end,
    STATE(398), 1,
      sym_comment,
    STATE(413), 1,
      aux_sym_if_statement_repeat1,
    STATE(478), 1,
      sym_elseif_statement,
    STATE(560), 1,
      sym_else_statement,
  [23780] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1088), 1,
      sym_identifier,
    ACTIONS(1090), 1,
      anon_sym_RPAREN,
    STATE(399), 1,
      sym_comment,
    STATE(468), 1,
      sym_vararg_expression,
    STATE(470), 1,
      sym_parameter,
    STATE(582), 1,
      sym__parameter_list,
  [23808] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1094), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(400), 1,
      sym_comment,
    ACTIONS(1092), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [23828] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1098), 1,
      anon_sym_SEMI,
    ACTIONS(1100), 1,
      anon_sym_else,
    STATE(401), 1,
      sym_comment,
    ACTIONS(1096), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [23850] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1104), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(402), 1,
      sym_comment,
    ACTIONS(1102), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [23870] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(403), 1,
      sym_comment,
    ACTIONS(1106), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [23896] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(404), 1,
      sym_comment,
    ACTIONS(1108), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [23922] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1112), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(405), 1,
      sym_comment,
    ACTIONS(1110), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [23942] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1112), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(406), 1,
      sym_comment,
    ACTIONS(1110), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [23962] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    STATE(407), 1,
      sym_comment,
    ACTIONS(1114), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [23988] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1118), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(408), 1,
      sym_comment,
    ACTIONS(1116), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [24008] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1122), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(409), 1,
      sym_comment,
    ACTIONS(1120), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [24028] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1124), 1,
      anon_sym_LT,
    ACTIONS(1126), 1,
      anon_sym_LPAREN,
    STATE(78), 1,
      sym_parameters,
    STATE(268), 1,
      sym__function_body,
    STATE(410), 1,
      sym_comment,
    STATE(505), 1,
      sym_generic_type_list,
  [24053] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1130), 1,
      anon_sym_else,
    STATE(411), 1,
      sym_comment,
    ACTIONS(1128), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [24072] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1132), 1,
      anon_sym_EQ,
    STATE(412), 1,
      sym_comment,
  [24097] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1134), 1,
      anon_sym_end,
    ACTIONS(1136), 1,
      anon_sym_elseif,
    ACTIONS(1139), 1,
      anon_sym_else,
    STATE(478), 1,
      sym_elseif_statement,
    STATE(413), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [24120] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1100), 1,
      anon_sym_else,
    STATE(414), 1,
      sym_comment,
    ACTIONS(1096), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [24139] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1141), 1,
      sym_identifier,
    STATE(415), 1,
      sym_comment,
    STATE(424), 1,
      sym__function_name,
    STATE(425), 1,
      sym__function_name_prefix_expression,
    STATE(437), 1,
      sym__function_name_dot_index_expression,
    STATE(502), 1,
      sym__function_name_method_index_expression,
  [24164] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1038), 1,
      anon_sym_COMMA,
    ACTIONS(1143), 1,
      anon_sym_EQ,
    ACTIONS(1145), 1,
      anon_sym_in,
    ACTIONS(1147), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_comment,
    STATE(496), 1,
      aux_sym__binding_list_repeat1,
  [24189] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1149), 1,
      anon_sym_RBRACK,
    STATE(417), 1,
      sym_comment,
  [24214] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1154), 1,
      anon_sym_RBRACE,
    STATE(132), 1,
      sym__field_sep,
    ACTIONS(1151), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(418), 2,
      sym_comment,
      aux_sym__field_list_repeat1,
  [24235] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1158), 1,
      anon_sym_RBRACE,
    STATE(119), 1,
      sym__field_sep,
    STATE(419), 1,
      sym_comment,
    STATE(422), 1,
      aux_sym__field_list_repeat1,
    ACTIONS(1156), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [24258] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1160), 1,
      anon_sym_COMMA,
    ACTIONS(1162), 1,
      anon_sym_GT,
    ACTIONS(1164), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(420), 1,
      sym_comment,
    STATE(486), 1,
      sym_vararg_expression,
    STATE(487), 1,
      aux_sym_generic_type_list_repeat1,
  [24283] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1124), 1,
      anon_sym_LT,
    ACTIONS(1126), 1,
      anon_sym_LPAREN,
    STATE(77), 1,
      sym__function_body,
    STATE(78), 1,
      sym_parameters,
    STATE(421), 1,
      sym_comment,
    STATE(505), 1,
      sym_generic_type_list,
  [24308] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(518), 1,
      anon_sym_RBRACE,
    STATE(121), 1,
      sym__field_sep,
    STATE(418), 1,
      aux_sym__field_list_repeat1,
    STATE(422), 1,
      sym_comment,
    ACTIONS(1156), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [24331] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(166), 1,
      anon_sym_LT2,
    ACTIONS(168), 1,
      anon_sym_PIPE,
    ACTIONS(170), 1,
      anon_sym_AMP,
    ACTIONS(172), 1,
      anon_sym_QMARK,
    ACTIONS(1166), 1,
      anon_sym_EQ,
    STATE(423), 1,
      sym_comment,
  [24356] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1124), 1,
      anon_sym_LT,
    ACTIONS(1126), 1,
      anon_sym_LPAREN,
    STATE(78), 1,
      sym_parameters,
    STATE(289), 1,
      sym__function_body,
    STATE(424), 1,
      sym_comment,
    STATE(505), 1,
      sym_generic_type_list,
  [24381] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1168), 1,
      anon_sym_DOT,
    ACTIONS(1170), 1,
      anon_sym_COLON,
    STATE(425), 1,
      sym_comment,
    ACTIONS(1172), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [24401] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(426), 1,
      sym_comment,
    ACTIONS(1174), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [24417] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1164), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(427), 1,
      sym_comment,
    STATE(501), 1,
      sym_vararg_expression,
    ACTIONS(1176), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [24437] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(335), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1088), 1,
      sym_identifier,
    STATE(428), 1,
      sym_comment,
    STATE(468), 1,
      sym_vararg_expression,
    STATE(504), 1,
      sym_parameter,
  [24459] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1178), 1,
      anon_sym_DQUOTE,
    STATE(429), 1,
      sym_comment,
    STATE(435), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24479] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(315), 1,
      anon_sym_else,
    STATE(430), 1,
      sym_comment,
    ACTIONS(1182), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [24497] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(416), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      sym_identifier,
    ACTIONS(1186), 1,
      anon_sym_RBRACE,
    STATE(431), 1,
      sym_comment,
    STATE(512), 1,
      sym_object_field_type,
  [24519] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1188), 1,
      sym_identifier,
    STATE(432), 1,
      sym_comment,
    STATE(552), 1,
      sym__binding_list,
    STATE(536), 2,
      sym_for_generic_clause,
      sym_for_numeric_clause,
  [24539] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(433), 1,
      sym_comment,
    ACTIONS(1190), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [24555] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1178), 1,
      anon_sym_SQUOTE,
    STATE(434), 1,
      sym_comment,
    STATE(439), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24575] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1194), 1,
      anon_sym_DQUOTE,
    STATE(435), 1,
      sym_comment,
    STATE(436), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24595] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1196), 1,
      anon_sym_DQUOTE,
    ACTIONS(1198), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
    STATE(436), 2,
      aux_sym__doublequote_string_content,
      sym_comment,
  [24613] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(437), 1,
      sym_comment,
    ACTIONS(1201), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [24629] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(416), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      sym_identifier,
    ACTIONS(1203), 1,
      anon_sym_RBRACE,
    STATE(438), 1,
      sym_comment,
    STATE(512), 1,
      sym_object_field_type,
  [24651] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1194), 1,
      anon_sym_SQUOTE,
    STATE(439), 1,
      sym_comment,
    STATE(442), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24671] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1205), 1,
      anon_sym_DQUOTE,
    STATE(440), 1,
      sym_comment,
    STATE(444), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24691] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1205), 1,
      anon_sym_SQUOTE,
    STATE(441), 1,
      sym_comment,
    STATE(445), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24711] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1207), 1,
      anon_sym_SQUOTE,
    ACTIONS(1209), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
    STATE(442), 2,
      aux_sym__singlequote_string_content,
      sym_comment,
  [24729] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1214), 1,
      anon_sym_else,
    STATE(443), 1,
      sym_comment,
    ACTIONS(1212), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [24747] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1216), 1,
      anon_sym_DQUOTE,
    STATE(436), 1,
      aux_sym__doublequote_string_content,
    STATE(444), 1,
      sym_comment,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24767] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1216), 1,
      anon_sym_SQUOTE,
    STATE(442), 1,
      aux_sym__singlequote_string_content,
    STATE(445), 1,
      sym_comment,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24787] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1218), 1,
      sym_identifier,
    ACTIONS(1220), 1,
      anon_sym_function,
    STATE(252), 1,
      sym__att_name_list,
    STATE(259), 1,
      sym__local_variable_assignment,
    STATE(446), 1,
      sym_comment,
  [24809] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(416), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      sym_identifier,
    ACTIONS(1222), 1,
      anon_sym_RBRACE,
    STATE(447), 1,
      sym_comment,
    STATE(512), 1,
      sym_object_field_type,
  [24831] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(416), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      sym_identifier,
    ACTIONS(1224), 1,
      anon_sym_RBRACE,
    STATE(448), 1,
      sym_comment,
    STATE(512), 1,
      sym_object_field_type,
  [24853] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1226), 1,
      anon_sym_DQUOTE,
    STATE(449), 1,
      sym_comment,
    STATE(451), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24873] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1226), 1,
      anon_sym_SQUOTE,
    STATE(450), 1,
      sym_comment,
    STATE(452), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24893] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1228), 1,
      anon_sym_DQUOTE,
    STATE(436), 1,
      aux_sym__doublequote_string_content,
    STATE(451), 1,
      sym_comment,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24913] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1228), 1,
      anon_sym_SQUOTE,
    STATE(442), 1,
      aux_sym__singlequote_string_content,
    STATE(452), 1,
      sym_comment,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24933] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1230), 1,
      anon_sym_COMMA,
    ACTIONS(1066), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(453), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [24951] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1233), 1,
      anon_sym_DQUOTE,
    STATE(454), 1,
      sym_comment,
    STATE(456), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24971] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1233), 1,
      anon_sym_SQUOTE,
    STATE(455), 1,
      sym_comment,
    STATE(457), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24991] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    STATE(436), 1,
      aux_sym__doublequote_string_content,
    STATE(456), 1,
      sym_comment,
    ACTIONS(1180), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [25011] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1235), 1,
      anon_sym_SQUOTE,
    STATE(442), 1,
      aux_sym__singlequote_string_content,
    STATE(457), 1,
      sym_comment,
    ACTIONS(1192), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [25031] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    STATE(458), 1,
      sym_comment,
    ACTIONS(1239), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [25048] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(1241), 1,
      anon_sym_COMMA,
    STATE(459), 1,
      sym_comment,
    STATE(474), 1,
      aux_sym_function_type_repeat1,
  [25067] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(460), 1,
      sym_comment,
    ACTIONS(1154), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [25082] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(416), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      sym_identifier,
    STATE(461), 1,
      sym_comment,
    STATE(512), 1,
      sym_object_field_type,
  [25101] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1186), 1,
      anon_sym_RBRACE,
    ACTIONS(1243), 1,
      anon_sym_COMMA,
    STATE(462), 1,
      sym_comment,
    STATE(476), 1,
      aux_sym_object_type_repeat1,
  [25120] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1160), 1,
      anon_sym_COMMA,
    ACTIONS(1245), 1,
      anon_sym_GT,
    STATE(463), 1,
      sym_comment,
    STATE(466), 1,
      aux_sym_generic_type_list_repeat1,
  [25139] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1247), 1,
      anon_sym_GT,
    STATE(464), 1,
      sym_comment,
    STATE(465), 1,
      aux_sym_generic_type_repeat1,
  [25158] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1042), 1,
      anon_sym_GT,
    ACTIONS(1249), 1,
      anon_sym_COMMA,
    STATE(465), 2,
      sym_comment,
      aux_sym_generic_type_repeat1,
  [25175] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1176), 1,
      anon_sym_GT,
    ACTIONS(1252), 1,
      anon_sym_COMMA,
    STATE(466), 2,
      sym_comment,
      aux_sym_generic_type_list_repeat1,
  [25192] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1257), 1,
      anon_sym_else,
    STATE(467), 1,
      sym_comment,
    ACTIONS(1255), 2,
      anon_sym_end,
      anon_sym_elseif,
  [25209] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1261), 1,
      anon_sym_COLON,
    STATE(468), 1,
      sym_comment,
    ACTIONS(1259), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [25226] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1263), 1,
      anon_sym_DQUOTE,
    STATE(469), 1,
      sym_comment,
    ACTIONS(1265), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [25243] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1267), 1,
      anon_sym_COMMA,
    ACTIONS(1269), 1,
      anon_sym_RPAREN,
    STATE(470), 1,
      sym_comment,
    STATE(488), 1,
      aux_sym__parameter_list_repeat1,
  [25262] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1038), 1,
      anon_sym_COMMA,
    ACTIONS(1271), 1,
      anon_sym_in,
    STATE(471), 1,
      sym_comment,
    STATE(477), 1,
      aux_sym__binding_list_repeat1,
  [25281] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1273), 1,
      anon_sym_RPAREN,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(472), 1,
      sym_comment,
  [25300] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1275), 1,
      anon_sym_COMMA,
    ACTIONS(1278), 1,
      anon_sym_RPAREN,
    STATE(473), 2,
      sym_comment,
      aux_sym__parameter_list_repeat1,
  [25317] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1280), 1,
      anon_sym_COMMA,
    ACTIONS(1283), 1,
      anon_sym_RPAREN,
    STATE(474), 2,
      sym_comment,
      aux_sym_function_type_repeat1,
  [25334] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_RPAREN,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(475), 1,
      sym_comment,
  [25353] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1287), 1,
      anon_sym_COMMA,
    ACTIONS(1290), 1,
      anon_sym_RBRACE,
    STATE(476), 2,
      sym_comment,
      aux_sym_object_type_repeat1,
  [25370] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1292), 1,
      anon_sym_COMMA,
    ACTIONS(1295), 1,
      anon_sym_in,
    STATE(477), 2,
      sym_comment,
      aux_sym__binding_list_repeat1,
  [25387] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1299), 1,
      anon_sym_else,
    STATE(478), 1,
      sym_comment,
    ACTIONS(1297), 2,
      anon_sym_end,
      anon_sym_elseif,
  [25404] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1034), 1,
      anon_sym_RPAREN,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(479), 1,
      sym_comment,
  [25423] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1301), 1,
      anon_sym_RPAREN,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(480), 1,
      sym_comment,
  [25442] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(590), 1,
      anon_sym_RBRACE,
    ACTIONS(1303), 1,
      anon_sym_COMMA,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(481), 1,
      sym_comment,
  [25461] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1305), 1,
      anon_sym_GT,
    STATE(482), 1,
      sym_comment,
    STATE(485), 1,
      aux_sym_generic_type_repeat1,
  [25480] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1305), 1,
      anon_sym_GT,
    STATE(465), 1,
      aux_sym_generic_type_repeat1,
    STATE(483), 1,
      sym_comment,
  [25499] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1222), 1,
      anon_sym_RBRACE,
    ACTIONS(1307), 1,
      anon_sym_COMMA,
    STATE(476), 1,
      aux_sym_object_type_repeat1,
    STATE(484), 1,
      sym_comment,
  [25518] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1309), 1,
      anon_sym_GT,
    STATE(465), 1,
      aux_sym_generic_type_repeat1,
    STATE(485), 1,
      sym_comment,
  [25537] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1160), 1,
      anon_sym_COMMA,
    ACTIONS(1311), 1,
      anon_sym_GT,
    STATE(463), 1,
      aux_sym_generic_type_list_repeat1,
    STATE(486), 1,
      sym_comment,
  [25556] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1160), 1,
      anon_sym_COMMA,
    ACTIONS(1311), 1,
      anon_sym_GT,
    STATE(466), 1,
      aux_sym_generic_type_list_repeat1,
    STATE(487), 1,
      sym_comment,
  [25575] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1267), 1,
      anon_sym_COMMA,
    ACTIONS(1313), 1,
      anon_sym_RPAREN,
    STATE(473), 1,
      aux_sym__parameter_list_repeat1,
    STATE(488), 1,
      sym_comment,
  [25594] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1317), 1,
      anon_sym_COLON,
    STATE(489), 1,
      sym_comment,
    ACTIONS(1315), 2,
      anon_sym_COMMA,
      anon_sym_in,
  [25611] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(554), 1,
      anon_sym_RBRACE,
    ACTIONS(1319), 1,
      anon_sym_COMMA,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(490), 1,
      sym_comment,
  [25630] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(491), 1,
      sym_comment,
  [25649] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(596), 1,
      anon_sym_RPAREN,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    STATE(474), 1,
      aux_sym_function_type_repeat1,
    STATE(492), 1,
      sym_comment,
  [25668] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1056), 1,
      anon_sym_RPAREN,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(493), 1,
      sym_comment,
  [25687] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(494), 1,
      sym_comment,
  [25706] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1323), 1,
      anon_sym_RPAREN,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
    STATE(495), 1,
      sym_comment,
  [25725] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1038), 1,
      anon_sym_COMMA,
    ACTIONS(1325), 1,
      anon_sym_in,
    STATE(477), 1,
      aux_sym__binding_list_repeat1,
    STATE(496), 1,
      sym_comment,
  [25744] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1327), 1,
      anon_sym_GT,
    STATE(464), 1,
      aux_sym_generic_type_repeat1,
    STATE(497), 1,
      sym_comment,
  [25763] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(1327), 1,
      anon_sym_GT,
    STATE(465), 1,
      aux_sym_generic_type_repeat1,
    STATE(498), 1,
      sym_comment,
  [25782] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(632), 1,
      anon_sym_COMMA,
    ACTIONS(1329), 1,
      anon_sym_RPAREN,
    STATE(317), 1,
      aux_sym__expression_list_repeat1,
    STATE(499), 1,
      sym_comment,
  [25801] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(500), 1,
      sym_comment,
    ACTIONS(1331), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [25815] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(501), 1,
      sym_comment,
    ACTIONS(1333), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [25829] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(502), 1,
      sym_comment,
    ACTIONS(1335), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [25843] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(503), 1,
      sym_comment,
    ACTIONS(349), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [25857] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(504), 1,
      sym_comment,
    ACTIONS(1278), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [25871] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1126), 1,
      anon_sym_LPAREN,
    STATE(98), 1,
      sym_parameters,
    STATE(505), 1,
      sym_comment,
  [25887] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(506), 1,
      sym_comment,
    ACTIONS(1337), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [25901] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1339), 1,
      anon_sym_RBRACE,
    STATE(507), 1,
      sym_comment,
  [25914] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1341), 1,
      anon_sym_end,
    STATE(508), 1,
      sym_comment,
  [25927] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(978), 1,
      anon_sym_COLON,
    STATE(509), 1,
      sym_comment,
  [25940] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1343), 1,
      sym__block_string_content,
    STATE(510), 1,
      sym_comment,
  [25953] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(538), 1,
      ts_builtin_sym_end,
    STATE(511), 1,
      sym_comment,
  [25966] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1345), 1,
      anon_sym_COLON,
    STATE(512), 1,
      sym_comment,
  [25979] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1347), 1,
      sym_identifier,
    STATE(513), 1,
      sym_comment,
  [25992] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1349), 1,
      sym__block_comment_end,
    STATE(514), 1,
      sym_comment,
  [26005] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1351), 1,
      sym_identifier,
    STATE(515), 1,
      sym_comment,
  [26018] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1353), 1,
      sym__block_string_end,
    STATE(516), 1,
      sym_comment,
  [26031] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1355), 1,
      anon_sym_DASH_GT,
    STATE(517), 1,
      sym_comment,
  [26044] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1357), 1,
      anon_sym_end,
    STATE(518), 1,
      sym_comment,
  [26057] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1359), 1,
      anon_sym_LPAREN,
    STATE(519), 1,
      sym_comment,
  [26070] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1361), 1,
      anon_sym_end,
    STATE(520), 1,
      sym_comment,
  [26083] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1363), 1,
      sym_identifier,
    STATE(521), 1,
      sym_comment,
  [26096] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1365), 1,
      sym__block_string_end,
    STATE(522), 1,
      sym_comment,
  [26109] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1367), 1,
      anon_sym_end,
    STATE(523), 1,
      sym_comment,
  [26122] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1369), 1,
      sym_identifier,
    STATE(524), 1,
      sym_comment,
  [26135] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1371), 1,
      ts_builtin_sym_end,
    STATE(525), 1,
      sym_comment,
  [26148] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(152), 1,
      anon_sym_DASH_GT,
    STATE(526), 1,
      sym_comment,
  [26161] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1373), 1,
      anon_sym_LPAREN,
    STATE(527), 1,
      sym_comment,
  [26174] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1062), 1,
      anon_sym_RBRACE,
    STATE(528), 1,
      sym_comment,
  [26187] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1375), 1,
      sym_identifier,
    STATE(529), 1,
      sym_comment,
  [26200] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1377), 1,
      sym_identifier,
    STATE(530), 1,
      sym_comment,
  [26213] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1379), 1,
      anon_sym_GT,
    STATE(531), 1,
      sym_comment,
  [26226] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1008), 1,
      anon_sym_DASH_GT,
    STATE(532), 1,
      sym_comment,
  [26239] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1052), 1,
      anon_sym_RBRACE,
    STATE(533), 1,
      sym_comment,
  [26252] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1381), 1,
      sym_identifier,
    STATE(534), 1,
      sym_comment,
  [26265] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1383), 1,
      anon_sym_end,
    STATE(535), 1,
      sym_comment,
  [26278] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1385), 1,
      anon_sym_do,
    STATE(536), 1,
      sym_comment,
  [26291] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1010), 1,
      anon_sym_DASH_GT,
    STATE(537), 1,
      sym_comment,
  [26304] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(528), 1,
      ts_builtin_sym_end,
    STATE(538), 1,
      sym_comment,
  [26317] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1387), 1,
      sym__block_comment_content,
    STATE(539), 1,
      sym_comment,
  [26330] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1389), 1,
      anon_sym_end,
    STATE(540), 1,
      sym_comment,
  [26343] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1391), 1,
      anon_sym_DASH_GT,
    STATE(541), 1,
      sym_comment,
  [26356] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1393), 1,
      anon_sym_LPAREN,
    STATE(542), 1,
      sym_comment,
  [26369] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1395), 1,
      anon_sym_do,
    STATE(543), 1,
      sym_comment,
  [26382] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1397), 1,
      anon_sym_DASH_GT,
    STATE(544), 1,
      sym_comment,
  [26395] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1399), 1,
      anon_sym_DASH_GT,
    STATE(545), 1,
      sym_comment,
  [26408] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1401), 1,
      anon_sym_end,
    STATE(546), 1,
      sym_comment,
  [26421] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1403), 1,
      anon_sym_DASH_GT,
    STATE(547), 1,
      sym_comment,
  [26434] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1405), 1,
      anon_sym_DASH_GT,
    STATE(548), 1,
      sym_comment,
  [26447] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1407), 1,
      anon_sym_DASH_GT,
    STATE(549), 1,
      sym_comment,
  [26460] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(146), 1,
      anon_sym_DASH_GT,
    STATE(550), 1,
      sym_comment,
  [26473] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1409), 1,
      anon_sym_end,
    STATE(551), 1,
      sym_comment,
  [26486] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1411), 1,
      anon_sym_in,
    STATE(552), 1,
      sym_comment,
  [26499] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1413), 1,
      sym__block_string_end,
    STATE(553), 1,
      sym_comment,
  [26512] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1415), 1,
      sym_identifier,
    STATE(554), 1,
      sym_comment,
  [26525] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1417), 1,
      anon_sym_type,
    STATE(555), 1,
      sym_comment,
  [26538] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1419), 1,
      sym_identifier,
    STATE(556), 1,
      sym_comment,
  [26551] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1421), 1,
      anon_sym_end,
    STATE(557), 1,
      sym_comment,
  [26564] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1423), 1,
      anon_sym_COLON,
    STATE(558), 1,
      sym_comment,
  [26577] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1425), 1,
      sym__block_string_end,
    STATE(559), 1,
      sym_comment,
  [26590] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1427), 1,
      anon_sym_end,
    STATE(560), 1,
      sym_comment,
  [26603] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1429), 1,
      sym_identifier,
    STATE(561), 1,
      sym_comment,
  [26616] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1431), 1,
      anon_sym_DASH_GT,
    STATE(562), 1,
      sym_comment,
  [26629] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1433), 1,
      sym__block_string_content,
    STATE(563), 1,
      sym_comment,
  [26642] = 4,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1435), 1,
      aux_sym_comment_token1,
    STATE(564), 1,
      sym_comment,
  [26655] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1437), 1,
      anon_sym_end,
    STATE(565), 1,
      sym_comment,
  [26668] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1439), 1,
      anon_sym_LPAREN,
    STATE(566), 1,
      sym_comment,
  [26681] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1004), 1,
      anon_sym_COLON,
    STATE(567), 1,
      sym_comment,
  [26694] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1441), 1,
      anon_sym_LPAREN,
    STATE(568), 1,
      sym_comment,
  [26707] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1443), 1,
      sym_identifier,
    STATE(569), 1,
      sym_comment,
  [26720] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1445), 1,
      sym_identifier,
    STATE(570), 1,
      sym_comment,
  [26733] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1447), 1,
      anon_sym_RBRACE,
    STATE(571), 1,
      sym_comment,
  [26746] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1449), 1,
      anon_sym_DASH_GT,
    STATE(572), 1,
      sym_comment,
  [26759] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1451), 1,
      ts_builtin_sym_end,
    STATE(573), 1,
      sym_comment,
  [26772] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1453), 1,
      anon_sym_EQ,
    STATE(574), 1,
      sym_comment,
  [26785] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1455), 1,
      anon_sym_until,
    STATE(575), 1,
      sym_comment,
  [26798] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1457), 1,
      sym__block_string_content,
    STATE(576), 1,
      sym_comment,
  [26811] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1459), 1,
      sym__block_string_content,
    STATE(577), 1,
      sym_comment,
  [26824] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1461), 1,
      anon_sym_end,
    STATE(578), 1,
      sym_comment,
  [26837] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(982), 1,
      anon_sym_COLON,
    STATE(579), 1,
      sym_comment,
  [26850] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1463), 1,
      anon_sym_DASH_GT,
    STATE(580), 1,
      sym_comment,
  [26863] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1465), 1,
      sym_identifier,
    STATE(581), 1,
      sym_comment,
  [26876] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
    STATE(582), 1,
      sym_comment,
  [26889] = 1,
    ACTIONS(1469), 1,
      ts_builtin_sym_end,
  [26893] = 1,
    ACTIONS(1471), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 73,
  [SMALL_STATE(4)] = 146,
  [SMALL_STATE(5)] = 219,
  [SMALL_STATE(6)] = 283,
  [SMALL_STATE(7)] = 351,
  [SMALL_STATE(8)] = 415,
  [SMALL_STATE(9)] = 479,
  [SMALL_STATE(10)] = 543,
  [SMALL_STATE(11)] = 611,
  [SMALL_STATE(12)] = 679,
  [SMALL_STATE(13)] = 743,
  [SMALL_STATE(14)] = 809,
  [SMALL_STATE(15)] = 873,
  [SMALL_STATE(16)] = 937,
  [SMALL_STATE(17)] = 1001,
  [SMALL_STATE(18)] = 1065,
  [SMALL_STATE(19)] = 1129,
  [SMALL_STATE(20)] = 1193,
  [SMALL_STATE(21)] = 1257,
  [SMALL_STATE(22)] = 1321,
  [SMALL_STATE(23)] = 1385,
  [SMALL_STATE(24)] = 1449,
  [SMALL_STATE(25)] = 1513,
  [SMALL_STATE(26)] = 1578,
  [SMALL_STATE(27)] = 1643,
  [SMALL_STATE(28)] = 1706,
  [SMALL_STATE(29)] = 1771,
  [SMALL_STATE(30)] = 1833,
  [SMALL_STATE(31)] = 1895,
  [SMALL_STATE(32)] = 1957,
  [SMALL_STATE(33)] = 2019,
  [SMALL_STATE(34)] = 2089,
  [SMALL_STATE(35)] = 2151,
  [SMALL_STATE(36)] = 2213,
  [SMALL_STATE(37)] = 2275,
  [SMALL_STATE(38)] = 2337,
  [SMALL_STATE(39)] = 2401,
  [SMALL_STATE(40)] = 2463,
  [SMALL_STATE(41)] = 2533,
  [SMALL_STATE(42)] = 2595,
  [SMALL_STATE(43)] = 2657,
  [SMALL_STATE(44)] = 2719,
  [SMALL_STATE(45)] = 2781,
  [SMALL_STATE(46)] = 2843,
  [SMALL_STATE(47)] = 2913,
  [SMALL_STATE(48)] = 2975,
  [SMALL_STATE(49)] = 3037,
  [SMALL_STATE(50)] = 3107,
  [SMALL_STATE(51)] = 3169,
  [SMALL_STATE(52)] = 3239,
  [SMALL_STATE(53)] = 3309,
  [SMALL_STATE(54)] = 3379,
  [SMALL_STATE(55)] = 3449,
  [SMALL_STATE(56)] = 3511,
  [SMALL_STATE(57)] = 3573,
  [SMALL_STATE(58)] = 3635,
  [SMALL_STATE(59)] = 3697,
  [SMALL_STATE(60)] = 3759,
  [SMALL_STATE(61)] = 3821,
  [SMALL_STATE(62)] = 3891,
  [SMALL_STATE(63)] = 3959,
  [SMALL_STATE(64)] = 4087,
  [SMALL_STATE(65)] = 4156,
  [SMALL_STATE(66)] = 4281,
  [SMALL_STATE(67)] = 4406,
  [SMALL_STATE(68)] = 4497,
  [SMALL_STATE(69)] = 4559,
  [SMALL_STATE(70)] = 4672,
  [SMALL_STATE(71)] = 4779,
  [SMALL_STATE(72)] = 4894,
  [SMALL_STATE(73)] = 4951,
  [SMALL_STATE(74)] = 5060,
  [SMALL_STATE(75)] = 5116,
  [SMALL_STATE(76)] = 5208,
  [SMALL_STATE(77)] = 5264,
  [SMALL_STATE(78)] = 5320,
  [SMALL_STATE(79)] = 5436,
  [SMALL_STATE(80)] = 5492,
  [SMALL_STATE(81)] = 5548,
  [SMALL_STATE(82)] = 5606,
  [SMALL_STATE(83)] = 5662,
  [SMALL_STATE(84)] = 5718,
  [SMALL_STATE(85)] = 5774,
  [SMALL_STATE(86)] = 5830,
  [SMALL_STATE(87)] = 5886,
  [SMALL_STATE(88)] = 5942,
  [SMALL_STATE(89)] = 6034,
  [SMALL_STATE(90)] = 6090,
  [SMALL_STATE(91)] = 6168,
  [SMALL_STATE(92)] = 6224,
  [SMALL_STATE(93)] = 6280,
  [SMALL_STATE(94)] = 6336,
  [SMALL_STATE(95)] = 6392,
  [SMALL_STATE(96)] = 6448,
  [SMALL_STATE(97)] = 6504,
  [SMALL_STATE(98)] = 6582,
  [SMALL_STATE(99)] = 6698,
  [SMALL_STATE(100)] = 6754,
  [SMALL_STATE(101)] = 6810,
  [SMALL_STATE(102)] = 6866,
  [SMALL_STATE(103)] = 6936,
  [SMALL_STATE(104)] = 7012,
  [SMALL_STATE(105)] = 7086,
  [SMALL_STATE(106)] = 7150,
  [SMALL_STATE(107)] = 7210,
  [SMALL_STATE(108)] = 7280,
  [SMALL_STATE(109)] = 7338,
  [SMALL_STATE(110)] = 7394,
  [SMALL_STATE(111)] = 7450,
  [SMALL_STATE(112)] = 7506,
  [SMALL_STATE(113)] = 7619,
  [SMALL_STATE(114)] = 7732,
  [SMALL_STATE(115)] = 7845,
  [SMALL_STATE(116)] = 7958,
  [SMALL_STATE(117)] = 8071,
  [SMALL_STATE(118)] = 8178,
  [SMALL_STATE(119)] = 8285,
  [SMALL_STATE(120)] = 8389,
  [SMALL_STATE(121)] = 8475,
  [SMALL_STATE(122)] = 8579,
  [SMALL_STATE(123)] = 8689,
  [SMALL_STATE(124)] = 8775,
  [SMALL_STATE(125)] = 8879,
  [SMALL_STATE(126)] = 8989,
  [SMALL_STATE(127)] = 9099,
  [SMALL_STATE(128)] = 9182,
  [SMALL_STATE(129)] = 9265,
  [SMALL_STATE(130)] = 9348,
  [SMALL_STATE(131)] = 9431,
  [SMALL_STATE(132)] = 9514,
  [SMALL_STATE(133)] = 9615,
  [SMALL_STATE(134)] = 9698,
  [SMALL_STATE(135)] = 9781,
  [SMALL_STATE(136)] = 9864,
  [SMALL_STATE(137)] = 9947,
  [SMALL_STATE(138)] = 10026,
  [SMALL_STATE(139)] = 10109,
  [SMALL_STATE(140)] = 10192,
  [SMALL_STATE(141)] = 10275,
  [SMALL_STATE(142)] = 10358,
  [SMALL_STATE(143)] = 10441,
  [SMALL_STATE(144)] = 10539,
  [SMALL_STATE(145)] = 10619,
  [SMALL_STATE(146)] = 10699,
  [SMALL_STATE(147)] = 10779,
  [SMALL_STATE(148)] = 10859,
  [SMALL_STATE(149)] = 10939,
  [SMALL_STATE(150)] = 11019,
  [SMALL_STATE(151)] = 11099,
  [SMALL_STATE(152)] = 11179,
  [SMALL_STATE(153)] = 11259,
  [SMALL_STATE(154)] = 11339,
  [SMALL_STATE(155)] = 11419,
  [SMALL_STATE(156)] = 11499,
  [SMALL_STATE(157)] = 11579,
  [SMALL_STATE(158)] = 11653,
  [SMALL_STATE(159)] = 11733,
  [SMALL_STATE(160)] = 11831,
  [SMALL_STATE(161)] = 11911,
  [SMALL_STATE(162)] = 11991,
  [SMALL_STATE(163)] = 12089,
  [SMALL_STATE(164)] = 12187,
  [SMALL_STATE(165)] = 12285,
  [SMALL_STATE(166)] = 12365,
  [SMALL_STATE(167)] = 12445,
  [SMALL_STATE(168)] = 12525,
  [SMALL_STATE(169)] = 12623,
  [SMALL_STATE(170)] = 12703,
  [SMALL_STATE(171)] = 12783,
  [SMALL_STATE(172)] = 12863,
  [SMALL_STATE(173)] = 12943,
  [SMALL_STATE(174)] = 13023,
  [SMALL_STATE(175)] = 13103,
  [SMALL_STATE(176)] = 13201,
  [SMALL_STATE(177)] = 13281,
  [SMALL_STATE(178)] = 13361,
  [SMALL_STATE(179)] = 13459,
  [SMALL_STATE(180)] = 13539,
  [SMALL_STATE(181)] = 13619,
  [SMALL_STATE(182)] = 13699,
  [SMALL_STATE(183)] = 13779,
  [SMALL_STATE(184)] = 13859,
  [SMALL_STATE(185)] = 13939,
  [SMALL_STATE(186)] = 14019,
  [SMALL_STATE(187)] = 14099,
  [SMALL_STATE(188)] = 14179,
  [SMALL_STATE(189)] = 14259,
  [SMALL_STATE(190)] = 14339,
  [SMALL_STATE(191)] = 14437,
  [SMALL_STATE(192)] = 14517,
  [SMALL_STATE(193)] = 14615,
  [SMALL_STATE(194)] = 14713,
  [SMALL_STATE(195)] = 14793,
  [SMALL_STATE(196)] = 14873,
  [SMALL_STATE(197)] = 14971,
  [SMALL_STATE(198)] = 15066,
  [SMALL_STATE(199)] = 15161,
  [SMALL_STATE(200)] = 15256,
  [SMALL_STATE(201)] = 15329,
  [SMALL_STATE(202)] = 15424,
  [SMALL_STATE(203)] = 15519,
  [SMALL_STATE(204)] = 15614,
  [SMALL_STATE(205)] = 15709,
  [SMALL_STATE(206)] = 15804,
  [SMALL_STATE(207)] = 15899,
  [SMALL_STATE(208)] = 15994,
  [SMALL_STATE(209)] = 16089,
  [SMALL_STATE(210)] = 16184,
  [SMALL_STATE(211)] = 16279,
  [SMALL_STATE(212)] = 16374,
  [SMALL_STATE(213)] = 16469,
  [SMALL_STATE(214)] = 16564,
  [SMALL_STATE(215)] = 16659,
  [SMALL_STATE(216)] = 16754,
  [SMALL_STATE(217)] = 16849,
  [SMALL_STATE(218)] = 16944,
  [SMALL_STATE(219)] = 17039,
  [SMALL_STATE(220)] = 17134,
  [SMALL_STATE(221)] = 17207,
  [SMALL_STATE(222)] = 17302,
  [SMALL_STATE(223)] = 17397,
  [SMALL_STATE(224)] = 17492,
  [SMALL_STATE(225)] = 17587,
  [SMALL_STATE(226)] = 17682,
  [SMALL_STATE(227)] = 17777,
  [SMALL_STATE(228)] = 17872,
  [SMALL_STATE(229)] = 17967,
  [SMALL_STATE(230)] = 18062,
  [SMALL_STATE(231)] = 18108,
  [SMALL_STATE(232)] = 18167,
  [SMALL_STATE(233)] = 18211,
  [SMALL_STATE(234)] = 18265,
  [SMALL_STATE(235)] = 18331,
  [SMALL_STATE(236)] = 18381,
  [SMALL_STATE(237)] = 18443,
  [SMALL_STATE(238)] = 18488,
  [SMALL_STATE(239)] = 18534,
  [SMALL_STATE(240)] = 18580,
  [SMALL_STATE(241)] = 18621,
  [SMALL_STATE(242)] = 18662,
  [SMALL_STATE(243)] = 18701,
  [SMALL_STATE(244)] = 18742,
  [SMALL_STATE(245)] = 18783,
  [SMALL_STATE(246)] = 18824,
  [SMALL_STATE(247)] = 18865,
  [SMALL_STATE(248)] = 18905,
  [SMALL_STATE(249)] = 18941,
  [SMALL_STATE(250)] = 18979,
  [SMALL_STATE(251)] = 19015,
  [SMALL_STATE(252)] = 19051,
  [SMALL_STATE(253)] = 19088,
  [SMALL_STATE(254)] = 19146,
  [SMALL_STATE(255)] = 19180,
  [SMALL_STATE(256)] = 19214,
  [SMALL_STATE(257)] = 19268,
  [SMALL_STATE(258)] = 19302,
  [SMALL_STATE(259)] = 19336,
  [SMALL_STATE(260)] = 19370,
  [SMALL_STATE(261)] = 19404,
  [SMALL_STATE(262)] = 19438,
  [SMALL_STATE(263)] = 19472,
  [SMALL_STATE(264)] = 19506,
  [SMALL_STATE(265)] = 19540,
  [SMALL_STATE(266)] = 19594,
  [SMALL_STATE(267)] = 19628,
  [SMALL_STATE(268)] = 19662,
  [SMALL_STATE(269)] = 19696,
  [SMALL_STATE(270)] = 19730,
  [SMALL_STATE(271)] = 19770,
  [SMALL_STATE(272)] = 19804,
  [SMALL_STATE(273)] = 19838,
  [SMALL_STATE(274)] = 19872,
  [SMALL_STATE(275)] = 19906,
  [SMALL_STATE(276)] = 19940,
  [SMALL_STATE(277)] = 19974,
  [SMALL_STATE(278)] = 20008,
  [SMALL_STATE(279)] = 20042,
  [SMALL_STATE(280)] = 20076,
  [SMALL_STATE(281)] = 20110,
  [SMALL_STATE(282)] = 20144,
  [SMALL_STATE(283)] = 20178,
  [SMALL_STATE(284)] = 20212,
  [SMALL_STATE(285)] = 20246,
  [SMALL_STATE(286)] = 20280,
  [SMALL_STATE(287)] = 20314,
  [SMALL_STATE(288)] = 20348,
  [SMALL_STATE(289)] = 20402,
  [SMALL_STATE(290)] = 20436,
  [SMALL_STATE(291)] = 20470,
  [SMALL_STATE(292)] = 20504,
  [SMALL_STATE(293)] = 20538,
  [SMALL_STATE(294)] = 20572,
  [SMALL_STATE(295)] = 20627,
  [SMALL_STATE(296)] = 20662,
  [SMALL_STATE(297)] = 20695,
  [SMALL_STATE(298)] = 20747,
  [SMALL_STATE(299)] = 20799,
  [SMALL_STATE(300)] = 20851,
  [SMALL_STATE(301)] = 20903,
  [SMALL_STATE(302)] = 20955,
  [SMALL_STATE(303)] = 21007,
  [SMALL_STATE(304)] = 21059,
  [SMALL_STATE(305)] = 21111,
  [SMALL_STATE(306)] = 21163,
  [SMALL_STATE(307)] = 21215,
  [SMALL_STATE(308)] = 21267,
  [SMALL_STATE(309)] = 21319,
  [SMALL_STATE(310)] = 21371,
  [SMALL_STATE(311)] = 21402,
  [SMALL_STATE(312)] = 21433,
  [SMALL_STATE(313)] = 21486,
  [SMALL_STATE(314)] = 21530,
  [SMALL_STATE(315)] = 21557,
  [SMALL_STATE(316)] = 21582,
  [SMALL_STATE(317)] = 21620,
  [SMALL_STATE(318)] = 21646,
  [SMALL_STATE(319)] = 21684,
  [SMALL_STATE(320)] = 21722,
  [SMALL_STATE(321)] = 21758,
  [SMALL_STATE(322)] = 21796,
  [SMALL_STATE(323)] = 21834,
  [SMALL_STATE(324)] = 21872,
  [SMALL_STATE(325)] = 21910,
  [SMALL_STATE(326)] = 21948,
  [SMALL_STATE(327)] = 21973,
  [SMALL_STATE(328)] = 22000,
  [SMALL_STATE(329)] = 22021,
  [SMALL_STATE(330)] = 22044,
  [SMALL_STATE(331)] = 22071,
  [SMALL_STATE(332)] = 22098,
  [SMALL_STATE(333)] = 22125,
  [SMALL_STATE(334)] = 22162,
  [SMALL_STATE(335)] = 22187,
  [SMALL_STATE(336)] = 22220,
  [SMALL_STATE(337)] = 22247,
  [SMALL_STATE(338)] = 22274,
  [SMALL_STATE(339)] = 22296,
  [SMALL_STATE(340)] = 22318,
  [SMALL_STATE(341)] = 22340,
  [SMALL_STATE(342)] = 22374,
  [SMALL_STATE(343)] = 22396,
  [SMALL_STATE(344)] = 22430,
  [SMALL_STATE(345)] = 22461,
  [SMALL_STATE(346)] = 22492,
  [SMALL_STATE(347)] = 22523,
  [SMALL_STATE(348)] = 22552,
  [SMALL_STATE(349)] = 22583,
  [SMALL_STATE(350)] = 22614,
  [SMALL_STATE(351)] = 22645,
  [SMALL_STATE(352)] = 22676,
  [SMALL_STATE(353)] = 22707,
  [SMALL_STATE(354)] = 22726,
  [SMALL_STATE(355)] = 22745,
  [SMALL_STATE(356)] = 22764,
  [SMALL_STATE(357)] = 22791,
  [SMALL_STATE(358)] = 22810,
  [SMALL_STATE(359)] = 22829,
  [SMALL_STATE(360)] = 22848,
  [SMALL_STATE(361)] = 22867,
  [SMALL_STATE(362)] = 22888,
  [SMALL_STATE(363)] = 22907,
  [SMALL_STATE(364)] = 22934,
  [SMALL_STATE(365)] = 22965,
  [SMALL_STATE(366)] = 22984,
  [SMALL_STATE(367)] = 23011,
  [SMALL_STATE(368)] = 23030,
  [SMALL_STATE(369)] = 23049,
  [SMALL_STATE(370)] = 23076,
  [SMALL_STATE(371)] = 23095,
  [SMALL_STATE(372)] = 23114,
  [SMALL_STATE(373)] = 23141,
  [SMALL_STATE(374)] = 23160,
  [SMALL_STATE(375)] = 23187,
  [SMALL_STATE(376)] = 23214,
  [SMALL_STATE(377)] = 23241,
  [SMALL_STATE(378)] = 23268,
  [SMALL_STATE(379)] = 23287,
  [SMALL_STATE(380)] = 23306,
  [SMALL_STATE(381)] = 23325,
  [SMALL_STATE(382)] = 23344,
  [SMALL_STATE(383)] = 23363,
  [SMALL_STATE(384)] = 23382,
  [SMALL_STATE(385)] = 23401,
  [SMALL_STATE(386)] = 23420,
  [SMALL_STATE(387)] = 23451,
  [SMALL_STATE(388)] = 23482,
  [SMALL_STATE(389)] = 23513,
  [SMALL_STATE(390)] = 23540,
  [SMALL_STATE(391)] = 23571,
  [SMALL_STATE(392)] = 23602,
  [SMALL_STATE(393)] = 23633,
  [SMALL_STATE(394)] = 23652,
  [SMALL_STATE(395)] = 23678,
  [SMALL_STATE(396)] = 23706,
  [SMALL_STATE(397)] = 23734,
  [SMALL_STATE(398)] = 23752,
  [SMALL_STATE(399)] = 23780,
  [SMALL_STATE(400)] = 23808,
  [SMALL_STATE(401)] = 23828,
  [SMALL_STATE(402)] = 23850,
  [SMALL_STATE(403)] = 23870,
  [SMALL_STATE(404)] = 23896,
  [SMALL_STATE(405)] = 23922,
  [SMALL_STATE(406)] = 23942,
  [SMALL_STATE(407)] = 23962,
  [SMALL_STATE(408)] = 23988,
  [SMALL_STATE(409)] = 24008,
  [SMALL_STATE(410)] = 24028,
  [SMALL_STATE(411)] = 24053,
  [SMALL_STATE(412)] = 24072,
  [SMALL_STATE(413)] = 24097,
  [SMALL_STATE(414)] = 24120,
  [SMALL_STATE(415)] = 24139,
  [SMALL_STATE(416)] = 24164,
  [SMALL_STATE(417)] = 24189,
  [SMALL_STATE(418)] = 24214,
  [SMALL_STATE(419)] = 24235,
  [SMALL_STATE(420)] = 24258,
  [SMALL_STATE(421)] = 24283,
  [SMALL_STATE(422)] = 24308,
  [SMALL_STATE(423)] = 24331,
  [SMALL_STATE(424)] = 24356,
  [SMALL_STATE(425)] = 24381,
  [SMALL_STATE(426)] = 24401,
  [SMALL_STATE(427)] = 24417,
  [SMALL_STATE(428)] = 24437,
  [SMALL_STATE(429)] = 24459,
  [SMALL_STATE(430)] = 24479,
  [SMALL_STATE(431)] = 24497,
  [SMALL_STATE(432)] = 24519,
  [SMALL_STATE(433)] = 24539,
  [SMALL_STATE(434)] = 24555,
  [SMALL_STATE(435)] = 24575,
  [SMALL_STATE(436)] = 24595,
  [SMALL_STATE(437)] = 24613,
  [SMALL_STATE(438)] = 24629,
  [SMALL_STATE(439)] = 24651,
  [SMALL_STATE(440)] = 24671,
  [SMALL_STATE(441)] = 24691,
  [SMALL_STATE(442)] = 24711,
  [SMALL_STATE(443)] = 24729,
  [SMALL_STATE(444)] = 24747,
  [SMALL_STATE(445)] = 24767,
  [SMALL_STATE(446)] = 24787,
  [SMALL_STATE(447)] = 24809,
  [SMALL_STATE(448)] = 24831,
  [SMALL_STATE(449)] = 24853,
  [SMALL_STATE(450)] = 24873,
  [SMALL_STATE(451)] = 24893,
  [SMALL_STATE(452)] = 24913,
  [SMALL_STATE(453)] = 24933,
  [SMALL_STATE(454)] = 24951,
  [SMALL_STATE(455)] = 24971,
  [SMALL_STATE(456)] = 24991,
  [SMALL_STATE(457)] = 25011,
  [SMALL_STATE(458)] = 25031,
  [SMALL_STATE(459)] = 25048,
  [SMALL_STATE(460)] = 25067,
  [SMALL_STATE(461)] = 25082,
  [SMALL_STATE(462)] = 25101,
  [SMALL_STATE(463)] = 25120,
  [SMALL_STATE(464)] = 25139,
  [SMALL_STATE(465)] = 25158,
  [SMALL_STATE(466)] = 25175,
  [SMALL_STATE(467)] = 25192,
  [SMALL_STATE(468)] = 25209,
  [SMALL_STATE(469)] = 25226,
  [SMALL_STATE(470)] = 25243,
  [SMALL_STATE(471)] = 25262,
  [SMALL_STATE(472)] = 25281,
  [SMALL_STATE(473)] = 25300,
  [SMALL_STATE(474)] = 25317,
  [SMALL_STATE(475)] = 25334,
  [SMALL_STATE(476)] = 25353,
  [SMALL_STATE(477)] = 25370,
  [SMALL_STATE(478)] = 25387,
  [SMALL_STATE(479)] = 25404,
  [SMALL_STATE(480)] = 25423,
  [SMALL_STATE(481)] = 25442,
  [SMALL_STATE(482)] = 25461,
  [SMALL_STATE(483)] = 25480,
  [SMALL_STATE(484)] = 25499,
  [SMALL_STATE(485)] = 25518,
  [SMALL_STATE(486)] = 25537,
  [SMALL_STATE(487)] = 25556,
  [SMALL_STATE(488)] = 25575,
  [SMALL_STATE(489)] = 25594,
  [SMALL_STATE(490)] = 25611,
  [SMALL_STATE(491)] = 25630,
  [SMALL_STATE(492)] = 25649,
  [SMALL_STATE(493)] = 25668,
  [SMALL_STATE(494)] = 25687,
  [SMALL_STATE(495)] = 25706,
  [SMALL_STATE(496)] = 25725,
  [SMALL_STATE(497)] = 25744,
  [SMALL_STATE(498)] = 25763,
  [SMALL_STATE(499)] = 25782,
  [SMALL_STATE(500)] = 25801,
  [SMALL_STATE(501)] = 25815,
  [SMALL_STATE(502)] = 25829,
  [SMALL_STATE(503)] = 25843,
  [SMALL_STATE(504)] = 25857,
  [SMALL_STATE(505)] = 25871,
  [SMALL_STATE(506)] = 25887,
  [SMALL_STATE(507)] = 25901,
  [SMALL_STATE(508)] = 25914,
  [SMALL_STATE(509)] = 25927,
  [SMALL_STATE(510)] = 25940,
  [SMALL_STATE(511)] = 25953,
  [SMALL_STATE(512)] = 25966,
  [SMALL_STATE(513)] = 25979,
  [SMALL_STATE(514)] = 25992,
  [SMALL_STATE(515)] = 26005,
  [SMALL_STATE(516)] = 26018,
  [SMALL_STATE(517)] = 26031,
  [SMALL_STATE(518)] = 26044,
  [SMALL_STATE(519)] = 26057,
  [SMALL_STATE(520)] = 26070,
  [SMALL_STATE(521)] = 26083,
  [SMALL_STATE(522)] = 26096,
  [SMALL_STATE(523)] = 26109,
  [SMALL_STATE(524)] = 26122,
  [SMALL_STATE(525)] = 26135,
  [SMALL_STATE(526)] = 26148,
  [SMALL_STATE(527)] = 26161,
  [SMALL_STATE(528)] = 26174,
  [SMALL_STATE(529)] = 26187,
  [SMALL_STATE(530)] = 26200,
  [SMALL_STATE(531)] = 26213,
  [SMALL_STATE(532)] = 26226,
  [SMALL_STATE(533)] = 26239,
  [SMALL_STATE(534)] = 26252,
  [SMALL_STATE(535)] = 26265,
  [SMALL_STATE(536)] = 26278,
  [SMALL_STATE(537)] = 26291,
  [SMALL_STATE(538)] = 26304,
  [SMALL_STATE(539)] = 26317,
  [SMALL_STATE(540)] = 26330,
  [SMALL_STATE(541)] = 26343,
  [SMALL_STATE(542)] = 26356,
  [SMALL_STATE(543)] = 26369,
  [SMALL_STATE(544)] = 26382,
  [SMALL_STATE(545)] = 26395,
  [SMALL_STATE(546)] = 26408,
  [SMALL_STATE(547)] = 26421,
  [SMALL_STATE(548)] = 26434,
  [SMALL_STATE(549)] = 26447,
  [SMALL_STATE(550)] = 26460,
  [SMALL_STATE(551)] = 26473,
  [SMALL_STATE(552)] = 26486,
  [SMALL_STATE(553)] = 26499,
  [SMALL_STATE(554)] = 26512,
  [SMALL_STATE(555)] = 26525,
  [SMALL_STATE(556)] = 26538,
  [SMALL_STATE(557)] = 26551,
  [SMALL_STATE(558)] = 26564,
  [SMALL_STATE(559)] = 26577,
  [SMALL_STATE(560)] = 26590,
  [SMALL_STATE(561)] = 26603,
  [SMALL_STATE(562)] = 26616,
  [SMALL_STATE(563)] = 26629,
  [SMALL_STATE(564)] = 26642,
  [SMALL_STATE(565)] = 26655,
  [SMALL_STATE(566)] = 26668,
  [SMALL_STATE(567)] = 26681,
  [SMALL_STATE(568)] = 26694,
  [SMALL_STATE(569)] = 26707,
  [SMALL_STATE(570)] = 26720,
  [SMALL_STATE(571)] = 26733,
  [SMALL_STATE(572)] = 26746,
  [SMALL_STATE(573)] = 26759,
  [SMALL_STATE(574)] = 26772,
  [SMALL_STATE(575)] = 26785,
  [SMALL_STATE(576)] = 26798,
  [SMALL_STATE(577)] = 26811,
  [SMALL_STATE(578)] = 26824,
  [SMALL_STATE(579)] = 26837,
  [SMALL_STATE(580)] = 26850,
  [SMALL_STATE(581)] = 26863,
  [SMALL_STATE(582)] = 26876,
  [SMALL_STATE(583)] = 26889,
  [SMALL_STATE(584)] = 26893,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 0),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 0),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_index_expression, 3, 0, 25),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_index_expression, 3, 0, 25),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracket_index_expression, 4, 0, 25),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracket_index_expression, 4, 0, 25),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string, 3, 0, 31),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_string, 3, 0, 31),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [61] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 1, 0, 0),
  [63] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 1, 0, 0),
  [65] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, 0, 11),
  [67] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, 0, 11),
  [69] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [71] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [75] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression, 1, 0, 0),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression, 1, 0, 0),
  [81] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_type, 2, 0, 0),
  [83] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_type, 2, 0, 0),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [91] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(581),
  [96] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [98] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 2, 0, 0),
  [106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 2, 0, 0),
  [108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 3, 0, 0),
  [110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 3, 0, 0),
  [112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 6),
  [114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 6),
  [116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 7),
  [118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 7),
  [120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string, 2, 0, 0),
  [122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_string, 2, 0, 0),
  [124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quote_string, 2, 0, 15),
  [126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quote_string, 2, 0, 15),
  [128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_string, 3, 0, 13),
  [130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_string, 3, 0, 13),
  [132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quote_string, 3, 0, 30),
  [134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quote_string, 3, 0, 30),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_type, 2, 0, 0),
  [138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_type, 2, 0, 0),
  [140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 0),
  [162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type, 2, 0, 0),
  [164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variadic_type, 2, 0, 0),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2, 0, 0),
  [176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2, 0, 0),
  [178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2, 0, 0),
  [180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_type, 2, 0, 0),
  [182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3, 0, 0),
  [184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3, 0, 0),
  [186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 3, 0, 0),
  [188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 3, 0, 0),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3, 0, 0),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 0),
  [200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 0),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4, 0, 0),
  [204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4, 0, 0),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 4, 0, 0),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 4, 0, 0),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5, 0, 0),
  [212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5, 0, 0),
  [214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 5, 0, 0),
  [216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 5, 0, 0),
  [218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6, 0, 0),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6, 0, 0),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6, 0, 0),
  [224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6, 0, 0),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 6, 0, 0),
  [228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 6, 0, 0),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 7, 0, 0),
  [232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 7, 0, 0),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 7, 0, 0),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 7, 0, 0),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 8, 0, 0),
  [240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 8, 0, 0),
  [242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 9, 0, 0),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 9, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 10, 0, 0),
  [248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 10, 0, 0),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 11, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 11, 0, 0),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 0),
  [256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 0),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, 0, 44),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, 0, 44),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 44),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 44),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(218),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1, 0, 0),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 3, 0, 34),
  [349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vararg_expression, 1, 0, 0),
  [351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vararg_expression, 1, 0, 0),
  [353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(2),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0),
  [360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(278),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(282),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(116),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(227),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(113),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(205),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(432),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(415),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(210),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(555),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(191),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, 0, 46),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, 0, 46),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, 0, 14),
  [428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, 0, 14),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, 0, 45),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, 0, 45),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 4, 0, 29),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 4, 0, 29),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 4, 0, 60),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 4, 0, 60),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 66),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 66),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 6, 0, 44),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 6, 0, 44),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 5, 0, 67),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 5, 0, 67),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 5, 0, 46),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 5, 0, 46),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 6, 0, 71),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 6, 0, 71),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, 0, 29),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, 0, 29),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 4, 0, 44),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 44),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 33),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 33),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 1, 0, 0),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 2, 0, 0),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 3, 0, 0),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 1, 0, 0),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 2, 0, 0),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 1, 0, 16),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 1, 0, 16),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 4, 0, 35),
  [606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 4, 0, 35),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, 0, 20),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, 0, 20),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 3, 0, 4),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 3, 0, 4),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 4, 0, 27),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 4, 0, 27),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 1, 0, 0),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 1, 0, 0),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 1, 0, 4),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 1, 0, 4),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 27),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 27),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 27),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 27),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 57),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 57),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 5, 0, 65),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 5, 0, 65),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, 0, 22),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, 0, 22),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41),
  [678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41), SHIFT_REPEAT(554),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, 0, 23),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, 0, 23),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 3, 0, 40),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 3, 0, 40),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 4, 0, 55),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 4, 0, 55),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 4, 0, 56),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 4, 0, 56),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 2, 0, 43),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 2, 0, 43),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 5, 0, 70),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 5, 0, 70),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 59),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 59),
  [709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 59), SHIFT_REPEAT(204),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attrib, 3, 0, 0),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attrib, 3, 0, 0),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 3, 0, 54),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 3, 0, 54),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 53),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 53),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 1, 0, 0),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 1, 0, 0),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, 0, 68),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 69),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 69),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 34),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 34),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 34),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 34),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 1),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 1),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 7, 0, 27),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 7, 0, 27),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 8, 0, 57),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 8, 0, 57),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 3),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 3),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, 0, 16),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 3, 0, 19),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 3, 0, 19),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 37),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, 0, 37),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 4, 0, 39),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_function_declaration, 4, 0, 39),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 24),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, 0, 24),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 1, 0, 4),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_statement, 3, 0, 24),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_statement, 3, 0, 24),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 2),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 2),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_variable_assignment, 3, 0, 42),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_variable_assignment, 3, 0, 42),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 61),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 61),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 62),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 62),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 63),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 63),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 2, 0, 0),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 2, 0, 0),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, 0, 47),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 21),
  [832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 21),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 48),
  [836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 48),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 44),
  [840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 44),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 49),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 49),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 50),
  [848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 50),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 5, 0, 64),
  [854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 27),
  [856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_sep, 1, 0, 0),
  [858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_sep, 1, 0, 0),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 7, 0, 72),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 2, 0, 12),
  [914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 28),
  [916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 28), SHIFT_REPEAT(335),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(201),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(405),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(226),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32),
  [948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(402),
  [951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(402),
  [954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(406),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 2, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 2, 0, 0),
  [973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(530),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding_list, 3, 0, 4),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_repeat1, 2, 0, 0),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__binding_list_repeat1, 4, 0, 27),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_index_expression, 3, 0, 26),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 0),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolation_string_content, 1, 0, 0),
  [1104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolation_string_content, 1, 0, 0),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 0),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 4, 0, 0),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__escape_sequence, 1, 0, 0),
  [1112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__escape_sequence, 1, 0, 0),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 4, 0, 0),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 18),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 18),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 0),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 0),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51),
  [1136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51), SHIFT_REPEAT(208),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding_list, 1, 0, 4),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2, 0, 0), SHIFT_REPEAT(296),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2, 0, 0),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 1, 0, 0),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, 0, 0),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, 0, 0),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 2, 0, 0),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1, 0, 0),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_dot_index_expression, 3, 0, 25),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__doublequote_string_content, 2, 0, 0),
  [1198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__doublequote_string_content, 2, 0, 0), SHIFT_REPEAT(469),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, 0, 8),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__singlequote_string_content, 2, 0, 0),
  [1209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__singlequote_string_content, 2, 0, 0), SHIFT_REPEAT(458),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2, 0, 0),
  [1214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2, 0, 0),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [1230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__singlequote_string_content, 1, 0, 0),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__singlequote_string_content, 1, 0, 0),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_type_repeat1, 2, 0, 0), SHIFT_REPEAT(156),
  [1252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 2, 0, 0), SHIFT_REPEAT(524),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_statement, 4, 0, 44),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 4, 0, 44),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__doublequote_string_content, 1, 0, 0),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__doublequote_string_content, 1, 0, 0),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 1, 0, 0),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding_list, 4, 0, 52),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(428),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0),
  [1280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2, 0, 0),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0),
  [1292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__binding_list_repeat1, 2, 0, 28), SHIFT_REPEAT(569),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__binding_list_repeat1, 2, 0, 28),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 36),
  [1299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 36),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2, 0, 0),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__binding_list_repeat1, 2, 0, 27),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding_list, 2, 0, 12),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_method_index_expression, 3, 0, 26),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 3, 0, 0),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, 0, 9),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_repeat1, 3, 0, 0),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 3, 0, 0),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 5, 0, 0),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 3, 0, 0),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_generic_clause, 3, 0, 38),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2, 0, 19),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_field_type, 3, 0, 0),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 4, 0, 0),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1451] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, 0, 5),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 3, 0, 13),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__block_comment_start = 0,
  ts_external_token__block_comment_content = 1,
  ts_external_token__block_comment_end = 2,
  ts_external_token__block_string_start = 3,
  ts_external_token__block_string_content = 4,
  ts_external_token__block_string_end = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__block_comment_start] = sym__block_comment_start,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__block_comment_end] = sym__block_comment_end,
  [ts_external_token__block_string_start] = sym__block_string_start,
  [ts_external_token__block_string_content] = sym__block_string_content,
  [ts_external_token__block_string_end] = sym__block_string_end,
};

static const bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_comment_end] = true,
    [ts_external_token__block_string_start] = true,
    [ts_external_token__block_string_content] = true,
    [ts_external_token__block_string_end] = true,
  },
  [2] = {
    [ts_external_token__block_comment_start] = true,
  },
  [3] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_start] = true,
  },
  [4] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_content] = true,
  },
  [5] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_end] = true,
  },
  [6] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_end] = true,
  },
  [7] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_luau_external_scanner_create(void);
void tree_sitter_luau_external_scanner_destroy(void *);
bool tree_sitter_luau_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_luau_external_scanner_serialize(void *, char *);
void tree_sitter_luau_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_luau(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_luau_external_scanner_create,
      tree_sitter_luau_external_scanner_destroy,
      tree_sitter_luau_external_scanner_scan,
      tree_sitter_luau_external_scanner_serialize,
      tree_sitter_luau_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
